<?php

class AcceptanceJourney extends CI_Controller
{

    function __construct()
    {
        parent::__construct();
        $this->load->model('AcceptanceJourneyModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }

    // get all Groups
    public function all()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $data = $this->AcceptanceJourneyModel->all();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض الكل ',
                'token' => $token,
                'data' => $data,
                'isAuth' => true,
                'total' => $this->AcceptanceJourneyModel->count_records()
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getNamesForSelect()
    {
        $accounts = $this->AccountingTreeModel->getNamesForSelect();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض اسماء الحسابات ',
                'data' => $accounts,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getAccount()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $Announce = $this->AccountingTreeModel->getAccount($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض حساب',
                'token' => $token,
                'data' => $Announce,
                'isAuth' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function add()
    {
        $token = $this->tokenmiddleware->main();
        //  $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $from = $this->input->post('from');
        $to = $this->input->post('to');
        $accounting_reg = $this->input->post('accounting_reg');
        $status = $this->input->post('status');
        $note = $this->input->post('note');

        $data = array(
            'from'=>$from,
            'to'=>$to,
            'accounting_reg'=>$accounting_reg,
            'status'=>$status,
            'note'=>$note
        );
        $account = $this->AccountingTreeModel->createAccount($data);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم اضافة الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
                'data'=> $account,
                'user'=>$user
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function updateAccount()
    {
        $token = $this->tokenmiddleware->main();
        //  $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $name = $this->input->post('name');
        $number = $this->input->post('number');

        $data = array(
            'hash'=>$hash,
            'name'=> $name,
            'number' => $number
        );
        $account = $this->AccountingTreeModel->updateAccount($data);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم تعديل الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
                'data'=> $account
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function deleteAccount()
    {
        $token = $this->tokenmiddleware->main();
        // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $this->AccountingTreeModel->deleteAccount($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم حذف الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

}