<?php
defined('BASEPATH') or exit('No direct script access allowed');

class AccountingTree extends CI_Controller
{

    function __construct()
    {
        parent::__construct();
        $this->load->model('AccountingTreeModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }

    // get all Groups
    public function getAccountings()
    {
        $token = $this->tokenmiddleware->main();
       // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $accountings = $this->AccountingTreeModel->getAccountings();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الحسابات',
                'token' => $token,
                'data' => $accountings,
                'isAuth' => true,
                'total' => $this->AccountingTreeModel->count_records()
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getNamesForSelect()
    {
        $accounts = $this->AccountingTreeModel->getNamesForSelect();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض اسماء الحسابات ',
                'data' => $accounts,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getAccount()
    {
        $token = $this->tokenmiddleware->main();
       // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $Announce = $this->AccountingTreeModel->getAccount($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض حساب',
                'token' => $token,
                'data' => $Announce,
                'isAuth' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function createAccount()
    {
        $token = $this->tokenmiddleware->main();
      //  $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->jwtmiddleware->createHash();
        $name = $this->input->post('name');
        $number = $this->input->post('number');
        
        $data = array(
            'hash'=>$hash,
            'name'=> $name,
            'number' => $number
        );
        $account = $this->AccountingTreeModel->createAccount($data);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم اضافة الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
                'data'=> $account
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function updateAccount()
    {
        $token = $this->tokenmiddleware->main();
      //  $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $name = $this->input->post('name');
        $number = $this->input->post('number');

        $data = array(
            'hash'=>$hash,
            'name'=> $name,
            'number' => $number
        );
        $account = $this->AccountingTreeModel->updateAccount($data);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم تعديل الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
                'data'=> $account
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function deleteAccount()
    {
        $token = $this->tokenmiddleware->main();
       // $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $this->AccountingTreeModel->deleteAccount($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم حذف الحساب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

}