<?php

class ArchievePayrollController extends CI_Controller
{
    public function __construct()
    {
        parent::__construct();
        $this->load->model('ArchievePayrollModel');
        $this->load->library('JwtMiddleware');
        $this->load->library('Middleware');
        $this->load->model('UserModel');
    }

    public  function  getGroupedArcheievedPayrollByHash()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $from = $this->input->get('from');
        $to = $this->input->get('to');

        $page = $this->input->get('page') ?? 1;
        $perPage = $this->input->get('perPage') ?? 10;
        $searchTerm = $this->input->get('q') ?? '';

        if(!empty( $from || $to)) {
            $result =  $this->ArchievePayrollModel->getGroupedArcheievedPayrollByHash($from , $to ,$page, $perPage, $searchTerm);
            $data = $result['data'];
            $total = $result['count'];
            $status = $result['status'];
            if(is_string($result)) {
                $this->sendResponse($status , $data, $token , null ,$total,true, );
            }

            $this->sendResponse($status , "عرض البيانات", $token , $data, $total ,true);

        } else {
            $this->sendResponse(400, "الرجاء ادخال البيانات", $token, "",0, true);
        }
    }

    public  function getArchivedPayroll()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $hash = $this->input->get('hash');

        $page = $this->input->get('page') ?? 1;
        $perPage = $this->input->get('perPage') ?? 10;
        $searchTerm = $this->input->get('q') ?? '';
        
        if(!empty($hash)) {
            $result =  $this->ArchievePayrollModel->getArchivedPayroll($hash,$page , $perPage , $searchTerm);

            $data = $result['data'];
            $total = $result['count'];
            $status = $result['status'];

            if(is_string($result)) {
                $this->sendResponse($status , $data, $token , null ,$total,true );
            }

            $this->sendResponse($status , "عرض البيانات", $token , $data, $total ,true);

        } else {
            $this->sendResponse(400, "الرجاء ادخال البيانات", $token, "",0, true);
        }

    }
    private function sendResponse($status, $message, $token, $data,$total, $isAuth, $action = null) {
        $response = array(
            'status' => $status,
            'message' => $message,
            'token' => $token,
            'data' => $data,
            'total' => $total,
            'isAuth' => $isAuth
        );

        if ($action !== null) {
            $response['action'] = $action;
        }

//        header('Content-Type: application/json; charset=utf-8');
        http_response_code($status);
        echo json_encode($response, JSON_UNESCAPED_UNICODE);
        exit();
    }
}