<?php
defined('BASEPATH') or exit('No direct script access allowed');

class CheckIn extends CI_Controller
{

    function __construct()
    {
        parent::__construct();
        $this->load->library('Middleware');
        $this->load->model('CheckInModel');
        $this->load->model('UserModel');
    }

    public function index()
    {
    }

    // get all Holidays
    public function getChecksIn()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $checksIn = $this->CheckInModel->getChecksIn();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل تسجيلات الدخول',
                'token' => $token,
                'data' => $checksIn,
                'isAuth' => true,
                'total' => $this->CheckInModel->count_records()
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }


    public function deleteCheckIn()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $data = $this->CheckInModel->deleteCheckIn($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم حذف الامر بنجاح',
                'token' => $token,
                'isAuth' => true,
                'data' => $data
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function createCheckIn()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $userHash = $user['hash'];

        $data = array(
            'user_hash' => $userHash,
            'note' => $this->input->post('note'),
            'lat' => $this->input->post('lat'),
            'lng' => $this->input->post('lng'),
            'hash' => $this->jwtmiddleware->createHash(),
            'mobile_info' => $this->input->post('mobile_info') ?? null,
        );

        $data = $this->CheckInModel->createCheckIn($data);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم  الاضافة بنجاح',
                'token' => $token,
                'isAuth' => true,
                'data' => $data
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function saveCurrentLocation()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $user_hash = $user['hash'];


        $note = $this->input->post('note');
        $lat = $this->input->post('lat');
        $lng = $this->input->post('lng');
        $in_out = $this->input->post('in_out');
        $fingerprint_time = $this->input->post('fingerprint_time');
        $mobile_info = $this->input->post('mobile_info') ?? null;
        $time = $this->input->post('time') ?? null;
        // create hash
        $hash = $this->jwtmiddleware->createHash();
        $data = $this->CheckInModel->saveCurrentLocation($user_hash, $note, $lat, $lng, $hash, $in_out, $fingerprint_time, $mobile_info, $time);
        $this->jwtmiddleware->insertNotToFirebase([
            "type" => "check_in",
            "user" => $user_hash,
            "note" => $note,
        ]);
        echo json_encode(
            array(
                'status' => 200,
                'data' => $data,
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
    public function getHistoryLocations()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $hash = $user['hash'];


        $data = $this->CheckInModel->getHistoryLocations($hash);
        echo json_encode(
            array(
                'status' => 200,
                'data' => $data,
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
}