<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Currency extends CI_Controller
{

    function __construct()
    {
        parent::__construct();
        $this->load->model('CurrencyModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }


    public function getALl()
    {
        $token = $this->tokenmiddleware->main();
        //$this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        
        $result = $this->CurrencyModel->get_all();
        echo json_encode(
            array(
                'status' => 200,
                'message' => ' عرض العملات بنجاح',
                'token' => $token,
                'data' => $result,
                'isAuth' => true,
                'total' => $this->CurrencyModel->count_records()
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function get()
    {
        $token = $this->tokenmiddleware->main();
        //$this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $result = $this->CurrencyModel->get($hash);
        if ($result) {
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'عرض العملات',
                    'token' => $token,
                    'data' => $result,
                    'isAuth' => true
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        } else {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء عرض العملات',
                    'token' => $token,
                    'isAuth' => true,
                    'hash' => $hash,
                    'result' => $result
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
        exit();
    }

    public function create()
    {
        $token = $this->tokenmiddleware->main();
        //$this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $data = array(
            'hash' => $this->jwtmiddleware->createHash(),
            'name' => $this->input->post('name'),
            'rate' => $this->input->post('rate'),
        );

        $result = $this->CurrencyModel->add($data);

        if ($result) {
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'تم إنشاء العملات بنجاح',
                    'token' => $token,
                    'data' => $result,
                    'isAuth' => true
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        } else {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء إنشاء العملات',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => true
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
    }

    public function update()
    {
        $token = $this->tokenmiddleware->main();
        //$this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $data = array(
            'name' => $this->input->post('name'),
            'rate' => $this->input->post('rate'),
        );
        $this->CurrencyModel->update($hash, $data);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم تعديل العملات بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function delete()
    {
        $token = $this->tokenmiddleware->main();
        //$this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $this->CurrencyModel->delete($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم حذف العملات بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
}