<?php
defined('BASEPATH') or exit('No direct script access allowed');
class FinancialDiscounts extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->model('FinancialDiscountsModel');

        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }
    public function getFinancialDiscounts()
    {

        $this->UserModel->checkPermission();

        $data = $this->FinancialDiscountsModel->getFinancialDiscounts();

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'FinancialDiscounts successfully retrieved',
                'data' => $data,
                'total' => $this->FinancialDiscountsModel->count_records()
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 404,
                'message' => 'No FinancialDiscounts found',
                'data' => [],
                'total' => $this->FinancialDiscountsModel->count_records()
            );
            $this->output->set_output(json_encode($response));
        }
    }

    public function getFinancialDiscount()
    {
        $this->UserModel->checkPermission();

        $id = $this->input->get("id");

        if (!$id) {
            $response = array(
                'status' => 500,
                'message' => 'FinancialDiscounts id not provided',
            );
            return $this->output->set_output(json_encode($response));
        }

        $data = $this->FinancialDiscountsModel->getFinancialDiscount($id);

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'FinancialDiscounts successfully retrieved',
                'data' => $data
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 404,
                'message' => 'FinancialDiscounts not found',
            );
            $this->output->set_output(json_encode($response));
        }
    }


    public function getCurrentUserFinancialDiscountsSelect()
    {
        $this->UserModel->checkPermission();

        $user_id = $this->input->get("emp_id");

        $data = $this->FinancialDiscountsModel->getCurrentUserFinancialDiscountsSelect($user_id);

        if (!empty($data)) {
            $response = array(
                'status' => 200,
                'message' => 'success get data',
                'data' => $data,
            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 200,
                'message' => 'null',
                'data' => [],
            );
            $this->output->set_output(json_encode($response));
        }
    }


    // public function getCurrentUserSpecifications()
    // {
    //     $this->UserModel->checkPermission();


    //     $user_id = $this->input->get("emp_id");


    //     $data = $this->SpecifactionModel->getCurrentUserSpecifications($user_id);

    //     if (!empty($data)) {
    //         $response = array(
    //             'status' => 200,
    //             'message' => 'success get data',
    //             'data' => $data,
    //             'action' => 'false'
    //         );
    //         $this->output->set_output(json_encode($response));
    //     } else {
    //         $response = array(
    //             'status' => 200,
    //             'message' => 'null',
    //             'data' => [],
    //             'action' => 'false'
    //         );
    //         $this->output->set_output(json_encode($response));
    //     }
    // }

    // public function insertUserSpecification()
    // {
    //     $this->UserModel->checkPermission();
    //     $user_id = $this->input->post("emp_id");
    //     $specification_id = $this->input->post("specification_id");

    //     $data = array(
    //         'emp_info_id' => $user_id,
    //         'specification_id' => $specification_id
    //     );
    //     $result = $this->SpecifactionModel->insertUserSpecification($data);
    //     if ($result) {
    //         $response = array(
    //             'status' => 200,
    //             'message' => 'success insert UserSpecification',
    //             'action' => 'true'
    //         );
    //         $this->output->set_output(json_encode($response));
    //     } else {
    //         $response = array(
    //             'status' => 500,
    //             'message' => 'failed insert UserSpecification',
    //             'action' => 'true'
    //         );
    //         $this->output->set_output(json_encode($response));
    //     }
    // }

    // public function deleteUserSpecification()
    // {
    //     $this->UserModel->checkPermission();
    //     $user_id = $this->input->post("emp_id");
    //     $specification_id = $this->input->post("specification_id");
    //     $result = $this->SpecifactionModel->deleteUserSpecification($user_id, $specification_id);
    //     if ($result) {
    //         $response = array(
    //             'status' => 200,
    //             'message' => 'success delete UserSpecification',
    //             'action' => 'true'
    //         );
    //         $this->output->set_output(json_encode($response));
    //     } else {
    //         $response = array(
    //             'status' => 200,
    //             'message' => 'failed delete UserSpecification',
    //             'action' => 'true'
    //         );
    //         $this->output->set_output(json_encode($response));
    //     }
    // }

    // public function updateUserSepcification()
    // {
    //     $this->UserModel->checkPermission();

    //     // Assuming you have similar input validation for the update as well

    //     $user_id = $this->input->post("emp_id");
    //     $specifications_array = $this->input->post('specifications_array'); // this should be array

    //     if ($user_id && !$specifications_array) {
    //         $this->SpecifactionModel->deletAllSpecificationForUser($user_id);

    //     }
    //     if (!$user_id || !is_array($specifications_array) || empty($specifications_array)) {
    //         return $this->sendResponse(400, 'تم ادخال بيانات خاطئه لمخخصات', true);
    //     }


    //     $this->db->trans_start();


    //     try {
    //         $currentUserSpecifications = $this->SpecifactionModel->getCurrentUserSpecifications($user_id);

    //         $currentUserSpecifications = is_array($currentUserSpecifications) ? $currentUserSpecifications : [];
    //         $specifications_array = is_array($specifications_array) ? $specifications_array : [];
    //         $toDelete = array_diff($currentUserSpecifications, $specifications_array);
    //         foreach ($toDelete as $specification_id) {
    //             $this->SpecifactionModel->deleteUserSpecification($user_id, $specification_id);
    //         }

    //         $toInsert = array_diff($specifications_array, $currentUserSpecifications);
    //         foreach ($toInsert as $specification_id) {
    //             $user_specificationsData = [
    //                 'emp_info_id' => $user_id,
    //                 'specification_id' => $specification_id
    //             ];
    //             $this->SpecifactionModel->insertUserSpecification($user_specificationsData);
    //         }

    //         $this->db->trans_complete();

    //         // Check the status of the transaction
    //         if ($this->db->trans_status() === FALSE) {
    //             $this->sendResponse(500, 'Transaction failed', false);
    //         } else {
    //             $this->sendResponse(200, 'تم تعديل المخصصات بنجاح', false);
    //         }
    //     } catch (Exception $e) {
    //         $this->db->trans_rollback();
    //         $this->sendResponse(500, 'Exception: ' . $e->getMessage(), false);
    //     }
    // }

    public function insertFinancialDiscounts()
    {
        $this->UserModel->checkPermission();

        $data = $this->input->post();

        $result = $this->FinancialDiscountsModel->insertFinancialDiscounts($data);

        $this->output->set_output(json_encode($result));
    }


    public function updateFinancialDiscounts()
    {
        $this->UserModel->checkPermission();

        $data = $this->input->post();

        if (empty($data['id'])) {
            $response = array(
                'status' => 400, // Use an appropriate HTTP status code for a bad request
                'message' => 'ID not provided for the update operation',
            );

            $this->output->set_output(json_encode($response));
            return;
        }
        $result = $this->FinancialDiscountsModel->updateFinancialDiscounts($data);

        if ($result) {
            $response = array(
                'status' => 200,
                'message' => 'تم تحديث المقطوعه بنجاح',
                'action' => 'true'

            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 500,
                'message' => 'فشل في تحديث المقطوعه',
                'action' => 'false'
            );
            $this->output->set_output(json_encode($response));
        }
    }


    public function deleteFinancialDiscounts()
    {
        $this->UserModel->checkPermission();

        $id = $this->input->post("id");

        $result = $this->FinancialDiscountsModel->deleteFinancialDiscounts($id);

        if ($result) {
            $response = array(
                'status' => 200,
                'message' => 'تم حذف المقطوعه بنجاح',
                'action' => 'true'

            );
            $this->output->set_output(json_encode($response));
        } else {
            $response = array(
                'status' => 500,
                'message' => 'فشل في حذف المقطوعه',
                'action' => 'true'

            );
            $this->output->set_output(json_encode($response));
        }
    }


    private function sendResponse($status, $message, $action = true, $total = null)
    {
        $response = array('status' => $status, 'message' => $message, 'action' => $action, 'total' => $total);
        $this->output->set_output(json_encode($response));
    }

}