<?php
defined('BASEPATH') or exit('No direct script access allowed');


class Items extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->model('ItemsModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }

    public function getAll()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $advances = $this->ItemsModel->getAll();
        echo json_encode(
            array(
                'status' => 200,
                'message' => "عرض الذمم",
                'token' => $token,
                'data' => $advances,
                'isAuth' => true,
                'total' => $this->ItemsModel->getCount()
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
    public function getItemsTypes()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $advances = $this->ItemsModel->getItemsTypes();
        echo json_encode(
            array(
                'status' => 200,
                'message' => "عرض انواع الموجودات",
                'token' => $token,
                'data' => $advances,
                'isAuth' => true,
                'total' => $this->ItemsModel->getCountTypes()
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function get()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $id = $this->input->get('id');
        $advance = $this->ItemsModel->get($id);
        echo json_encode(
            array(
                'status' => 200,
                'message' => "عرض الذمة",
                'token' => $token,
                'data' => $advance,
                'isAuth' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
    public function getItemType()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();

        $id = $this->input->get('id');
        $advance = $this->ItemsModel->getItemType($id);
        echo json_encode(
            array(
                'status' => 200,
                'message' => "عرض نوع الموجودات",
                'token' => $token,
                'data' => $advance,
                'isAuth' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function create()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $user_hash = $user['hash'];
        // check if advance created

        $data = $this->input->post();
        $advance = $this->ItemsModel->create($data);
        echo json_encode(
            array(
                'status' => 200,
                'message' => "تم اضافة الذمة",
                'token' => $token,
                'data' => $advance,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
    }
    public function createItemType()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        // check if advance created

        $data = $this->input->post();
        $advance = $this->ItemsModel->createItemType($data);
        echo json_encode(
            array(
                'status' => 200,
                'message' => "تم اضافة نوع الموجودات",
                'token' => $token,
                'data' => $advance,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
    }

    public function delete()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $id = $this->input->post('hash');
        $advance = $this->ItemsModel->delete($id);


        if (is_string($advance)) {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => $advance,
                    'token' => $token,
                    'data' => $advance,
                    'isAuth' => true,
                    'action' => true,
                ),
                JSON_UNESCAPED_UNICODE
            );

            exit();
        }

        echo json_encode(
            array(
                'status' => 200,
                'message' => "تم حذف الذمة",
                'token' => $token,
                'data' => $advance,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
    }
    public function deleteItemType()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $id = $this->input->post('hash');

        $advance = $this->ItemsModel->deleteItemType($id);


        if (is_string($advance)) {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => $advance,
                    'token' => $token,
                    'data' => $advance,
                    'isAuth' => true,
                    'action' => true,
                ),
                JSON_UNESCAPED_UNICODE
            );

            exit();
        }

        echo json_encode(
            array(
                'status' => 200,
                'message' => "تم حذف الموجوده",
                'token' => $token,
                'data' => $advance,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
    }

    public function update()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $id = $this->input->post('id');
        $advance = $this->ItemsModel->update($id);
        echo json_encode(
            array(
                'status' => 200,
                'message' => "تم تعديل الذمة",
                'token' => $token,
                'data' => $advance,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
    }
    public function updateItemType()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $id = $this->input->post('id');
        $advance = $this->ItemsModel->updateItemType($id);
        echo json_encode(
            array(
                'status' => 200,
                'message' => "تم تعديل الموجوده",
                'token' => $token,
                'data' => $advance,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
    }

    public function getItems()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $items = $this->ItemsModel->getItems();
        echo json_encode(
            array(
                'status' => 200,
                'message' => "عرض الاصناف",
                'token' => $token,
                'data' => $items,
                'isAuth' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

}

