<?php
defined('BASEPATH') or exit('No direct script access allowed');

class OrderType extends CI_Controller
{

    function __construct()
    {
        parent::__construct();
        $this->load->model('OrderTypeModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }

    // get all Groups
    public function getOrderTypes()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $OrderTypes = $this->OrderTypeModel->getOrderTypes();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض كل الاوامر',
                'token' => $token,
                'data' => $OrderTypes,
                'isAuth' => true,
                'total' => $this->OrderTypeModel->count_records()
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getOrderType()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $OrderType = $this->OrderTypeModel->getOrderType($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'عرض أمر',
                'token' => $token,
                'data' => $OrderType,
                'isAuth' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function createOrderType()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $data = array(
            'hash' => $this->jwtmiddleware->createHash(),
            'title' => $this->input->post('title'),
        );
        $this->OrderTypeModel->addOrderType($data);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم اضافة الامر بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function updateOrderType()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $data = array(
            'title' => $this->input->post('title'),
        );
        $this->OrderTypeModel->updateOrderType($hash, $data);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم تعديل الامر بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function deleteOrderType()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $this->OrderTypeModel->deleteOrderType($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم حذف الامر بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
}