<?php
defined('BASEPATH') or exit('No direct script access allowed');

class SubscribersCustomersFTTHController extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->model('SubscribersCustomersFTTHModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');

    }

    public function testInsertMutedNot()
    {
        $this->SubscribersCustomersFTTHModel->testInsertMutedNot();
    }

    public function insertCustomerData()
    {
        $data = $this->input->post('data');
        $this->SubscribersCustomersFTTHModel->insertCustomerData($data);
        $this->sendResponse(200, [], 'Data inserted successfully');
    }

    public function insertCustomerDataExpired()
    {
        $data = $this->input->post('data');
        $this->SubscribersCustomersFTTHModel->insertCustomerDataExpired($data);
        $this->sendResponse(200, [], 'Data inserted successfully');
    }

    public function getZonesSelect()
    {
        $data = $this->SubscribersCustomersFTTHModel->getZonesSelect();
        $this->sendResponse(200, $data, 'Data retrieved successfully');
    }

    public function getDataByZoneId()
    {
        $zoneId = $this->input->get('zoneId');
        $data = $this->SubscribersCustomersFTTHModel->getDataByZoneId($zoneId);
        $this->sendResponse(200, $data, 'Data retrieved successfully');
    }

    public function getCustomerByFAT()
    {
        $FAT = $this->input->get('FAT');
        $data = $this->SubscribersCustomersFTTHModel->getCustomerByFAT($FAT);
        $this->sendResponse(200, $data, 'Data retrieved successfully');
    }

    public function getCustomerInformation()
    {
        $customerId = $this->input->get('id');

        if (empty($customerId)) {
            $this->sendResponse(400, [], 'Invalid customer ID');
        }

        $data = $this->SubscribersCustomersFTTHModel->getCustomerInformation($customerId);
        $this->sendResponse(200, $data, 'Data retrieved successfully');

    }

    public function getZonesNotWorking()
    {
        $data = $this->SubscribersCustomersFTTHModel->getZonesNotWorking();
        $this->sendResponse(200, $data['data'], 'Data retrieved successfully', $this->SubscribersCustomersFTTHModel->getZonesNotWorkingCount(), ['updated_at' => $data['updated_at']]);
    }

    public function getCustomersNotWorkingCuzZone()
    {
        $zoneId = $this->input->get('zoneId');
        $res = $this->SubscribersCustomersFTTHModel->getCustomersNotWorkingCuzZone($zoneId);
        $data = $res['data'];
        $total = $res['total'];
        // $updatedAt = $res['updated_at'];
        $this->sendResponse(200, $data, 'Data retrieved successfully', $total, ['updated_at' => $res['updated_at']]);
    }



    public function getAllCustomersWorkingAndNotWorking()
    {
        $res = $this->SubscribersCustomersFTTHModel->getAllCustomersWorkingAndNotWorking();
        $data = $res['data'];
        $total = $res['total'];
        $updatedAt = $res['updated_at'];
        $this->sendResponse(200, $data, 'Data retrieved successfully', $total, ['updated_at' => $res['updated_at']]);
    }

    public function getFtthCustomersExpired()
    {
        $res = $this->SubscribersCustomersFTTHModel->getFtthCustomersExpired();
        $data = $res['data'];
        $total = $res['total'];
        $updatedAt = $res['updated_at'];
        $this->sendResponse(200, $data, 'Data retrieved successfully', $total, ['updated_at' => $res['updated_at']]);
    }

    public function getZonesOptionsNotWorking()
    {
        $data = $this->SubscribersCustomersFTTHModel->getZonesOptionsNotWorking();
        $this->sendResponse(200, $data, 'Data retrieved successfully');
    }

    public function insertCustomerInforamtionData()
    {
        $data = $this->input->post('data') ?? null;

        if (empty($data)) {
            $this->sendResponse(400, [], 'Invalid data: data is required');
            return;
        }

        $this->SubscribersCustomersFTTHModel->insertCustomerInforamtionData($data);
        $this->sendResponse(200, [], 'Data inserted successfully');
    }

    public function insertZonesData()
    {
        $data = $this->input->post('data');
        $this->SubscribersCustomersFTTHModel->insertZonesData($data);
        $this->sendResponse(200, [], 'Data inserted successfully');
    }

    public function insert()
    {
        $data = $this->input->post('data');
        $this->SubscribersCustomersFTTHModel->insertCustomerData($data);
        $this->sendResponse(200, [], 'Data inserted successfully');
    }

    public function getCustomerDataActiveFalse()
    {
        $data = $this->SubscribersCustomersFTTHModel->getCustomerDataActiveFalse();
        $this->sendResponse(200, $data, 'Data retrieved successfully');
    }

    public function getCustomerDataExpiringSoon()
    {
        $res = $this->SubscribersCustomersFTTHModel->getCustomerDataExpiringSoon();
        $data = $res['data'];
        $updatedAt = $res['updated_at'];
        $total = $res['total'];
        $this->sendResponse(200, $data, 'Data retrieved successfully', $total, ['updated_at' => $updatedAt]);
    }
    public function getCustomerDataExpiringSoonWithInFourHours()
    {
        $res = $this->SubscribersCustomersFTTHModel->getCustomerDataExpiringSoonWithInFourHours();
        $data = $res['data'];
        $updatedAt = $res['updated_at'];
        $total = $res['total'];
        $this->sendResponse(200, $data, 'Data retrieved successfully', $total, ['updated_at' => $updatedAt]);
    }

    public function getCustomersExpired()
    {
        $data = $this->SubscribersCustomersFTTHModel->getCustomersExpired();
        $updatedAt = $data['updated_at'];
        $this->sendResponse(200, $data['data'], 'Data retrieved successfully', $this->SubscribersCustomersFTTHModel->getCusotmerExpiredCount(), ['updated_at' => $updatedAt]);
    }
    private function sendResponse($status, $data, $message = null, $total = null, ...$extraParams)
    {
        http_response_code($status);
        // Base response structure
        $response = [
            'status' => $status,
            'data' => $data,
            'message' => $message,
            'isAuth' => true,
        ];

        // Add 'total' to the response if provided
        if ($total !== null) {
            $response['total'] = $total;
        }

        // Merge any additional parameters into the response
        foreach ($extraParams as $param) {
            if (is_array($param)) {
                $response = array_merge($response, $param);
            }
        }

        // Output JSON response
        echo json_encode($response, JSON_UNESCAPED_UNICODE);
        exit();
    }


    public function getAllCustomersNotWorking()
    {
        $res = $this->SubscribersCustomersFTTHModel->getAllCustomersNotWorking();
        $data = $res['data'];
        $total = $res['total'];


        $this->sendResponse(200, $data, 'Data retrieved successfully', $total, ['updated_at' => $res['updated_at']]);
    }

    public function getCustomersNotWorkingZonesOptions()
    {
        $res = $this->SubscribersCustomersFTTHModel->getCustomersNotWorkingZonesOptions();
        $this->sendResponse(200, $res, 'Data retrieved successfully');
    }


    public function getCustomerPowerAndStatusById()
    {
        $username = $this->input->get('username');
        $data = $this->SubscribersCustomersFTTHModel->getCustomerPowerAndStatusById($username);
        $this->sendResponse(200, $data, 'Data retrieved successfully');
    }

    public function getCustomerTickets()
    {
        $params = $this->input->get();
        $data = $this->SubscribersCustomersFTTHModel->getCustomerTickets($params);
        $this->sendResponse(200, $data, 'Data retrieved successfully');
    }

    public function getTokenFTTH()
    {
        $token = $this->SubscribersCustomersFTTHModel->getTokenFTTH();
        $this->sendResponse(200, $token, 'Data retrieved successfully');
    }
}