<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Task extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->model('TaskModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');
    }

    public function index()
    {
    }

    // get all Groups
    public function getALl()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];

        $headers = apache_request_headers();
        $page = $this->input->get('page') ?? 1;
        $perPage = $this->input->get('perPage') ?? 10;
        $search = $this->input->get('q') ?? '';
        $department = $this->input->get('department') ?? '';
        $name = $this->input->get('name') ?? '';
        $today = $headers['today'] ?? false;
        $projectValue = $this->input->get('projectValue') ?? '';
        $is_simple_task = $this->input->get('isSimpleTask') ?? '';
        $task_status = $this->input->get('task_status') ?? '';

        $result = $this->TaskModel->get_all($page, $perPage, $search, $today, $department, $name, $projectValue, $is_simple_task, $task_status, $user);
        echo json_encode(
            array(
                'status' => 200,
                'message' => ' عرض المشاريع بنجاح',
                'token' => $token,
                'data' => $result['data'],
                'isAuth' => true,
                'total' => $result['totalRows'],
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getTaskStatusOptions()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];
        $result = $this->TaskModel->getTasksStatusOptions();
        echo json_encode(
            array(
                'status' => 200,
                'message' => ' عرض حالات الواجبات',
                'token' => $token,
                'data' => $result,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();

    }

    public function getAllTasksToday()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];

        $headers = apache_request_headers();
        $page = $this->input->get('page') ?? 1;
        $perPage = $this->input->get('perPage') ?? 10;
        $search = $this->input->get('q') ?? '';
        $department = $this->input->get('department') ?? '';
        $name = $this->input->get('name') ?? '';
        $today = $headers['today'] ?? true;
        $projectValue = $this->input->get('projectValue') ?? '';
        $is_simple_task = $this->input->get('isSimpleTask') ?? '';
        $task_status = $this->input->get('task_status') ?? '';

        $result = $this->TaskModel->getAllTasksToday($page, $perPage, $search, $today, $department, $name, $projectValue, $is_simple_task, $task_status, $user);
        echo json_encode(
            array(
                'status' => 200,
                'message' => ' عرض المشاريع بنجاح',
                'token' => $token,
                'data' => $result['data'],
                'isAuth' => true,
                'total' => $result['totalRows'],
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getUserTasks()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        // $user = $this->jwtmiddleware->decode($token)['hash'];
        $requestData = array(
            'user' => $this->input->get('user_hash'),
            'page' => $this->input->get('page') ?? 1,
            'perpage' => $this->input->get('perPage') ?? 10,
            'search' => $this->input->get('q') ?? '',
            'department' => $this->input->get('department') ?? '',
            'name' => $this->input->get('name') ?? '',
            'today' => $this->input->get('today') ?? false,
            'projectValue' => $this->input->get('projectValue') ?? '',
            'is_simple_task' => $this->input->get('isSimpleTask') ?? '',
            'task_status' => $this->input->get('task_status') ?? '',
        );

        $this->validateData($requestData);

        $result = $this->TaskModel->getUserTasks($requestData);
        $data = $result['data'];
        $total = $result['total'];

        echo json_encode(
            array(
                'status' => 200,
                'message' => ' عرض الواجبات بنجاح',
                'token' => $token,
                'data' => $data,
                'isAuth' => true,
                'total' => $total,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    private function validateData($requestData)
    {
        if (empty($requestData['user'])) {
            throw new Exception('User hash cannot be null or not passed.');
        }
        // Add other validation checks if needed
    }
    public function get_pending_tasks()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];

        $headers = apache_request_headers();
        $page = $this->input->get('page') ?? 1;
        $perPage = $this->input->get('perPage') ?? 10;
        $search = $this->input->get('q') ?? '';
        $department = $this->input->get('department') ?? '';
        $name = $this->input->get('name') ?? '';
        $today = $headers['today'] ?? false;
        $projectValue = $this->input->get('projectValue') ?? '';
        $is_simple_task = $this->input->get('isSimpleTask') ?? '';
        $task_status = $this->input->get('task_status') ?? '';
        $phone_num = $this->input->get('phone_num') ?? '';
        $sender_name = $this->input->get('sender_name') ?? '';
        $result = $this->TaskModel->get_pending_tasks($page, $perPage, $search, $today, $department, $name, $projectValue, $is_simple_task, $task_status, $user);

        echo json_encode(
            array(
                'status' => 200,
                'message' => ' عرض المشاريع بنجاح',
                'token' => $token,
                'data' => $result,
                'isAuth' => true,
                'total' => $this->TaskModel->get_pending_tasks_count([
                    'search' => $search,
                    'today' => $today,
                    'department' => $department,
                    'name' => $name,
                    'projectHash' => $projectValue,
                    'is_simple_task' => $is_simple_task,
                    'task_status' => $task_status,
                    'user' => $user,
                    'phone_num' => $phone_num,
                    'sender_name' => $sender_name
                ])
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getTasksOptions()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];

        $result = $this->TaskModel->getTasksOptions();

        echo json_encode(
            array(
                'status' => 200,
                'message' => ' عرض المشاريع بنجاح',
                'token' => $token,
                'data' => $result,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getPendingTasksOptions()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];

        $result = $this->TaskModel->getPendingTasksOptions();

        echo json_encode(
            array(
                'status' => 200,
                'message' => ' عرض المشاريع بنجاح',
                'token' => $token,
                'data' => $result,
                'isAuth' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
    public function getALlWithOverDueDeadLine()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $headers = apache_request_headers();
        $page = $headers['page'] ?? 1;
        $perPage = $headers['perPage'] ?? 10;
        $search = $this->input->get('q') ?? '';
        $department = $this->input->get('department') ?? '';
        $name = $this->input->get('name') ?? '';
        $today = $headers['today'] ?? false;
        $result = $this->TaskModel->retrieveEmployeesWithOverdueTasks($page, $perPage, $search, $today, $department, $name);

        echo json_encode(
            array(
                'status' => 200,
                'message' => ' عرض المشاريع بنجاح',
                'token' => $token,
                'data' => $result,
                'isAuth' => true,
                'total' => $this->TaskModel->count_records_overDue_deadline($search, $today, $department, $name),
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }
    public function getSimpleTasksStillWithUser()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];

        $headers = apache_request_headers();
        $page = $this->input->get('page') ?? 1;
        $perPage = $this->input->get('perPage') ?? 10;
        $search = $this->input->get('q') ?? '';
        $department = $this->input->get('department') ?? '';
        $name = $this->input->get('name') ?? '';
        $today = $headers['today'] ?? false;
        $projectValue = $this->input->get('projectValue') ?? '';
        $is_simple_task = $this->input->get('isSimpleTask') ?? '';
        $task_status = $this->input->get('task_status') ?? '';

        $result = $this->TaskModel->getSimpleTasksStillWithUser($page, $perPage, $search, $today, $department, $name, $projectValue, $is_simple_task, $task_status, $user);
        echo json_encode(
            array(
                'status' => 200,
                'message' => ' عرض المشاريع بنجاح',
                'token' => $token,
                'data' => $result['data'],
                'isAuth' => true,
                'total' => $result['totalRows'],
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function get()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $result = $this->TaskModel->get($hash);
        if ($result) {
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'عرض الواجب',
                    'token' => $token,
                    'data' => $result,
                    'isAuth' => true,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        } else {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء عرض الواجب',
                    'token' => $token,
                    'isAuth' => true,
                    'hash' => $hash,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
    }
    public function getTaskDetails()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $result = $this->TaskModel->getTaskDetails($hash);
        if ($result) {
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'عرض الواجب',
                    'token' => $token,
                    'data' => $result,
                    'isAuth' => true,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        } else {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء عرض الواجب',
                    'token' => $token,
                    'isAuth' => true,
                    'hash' => $hash,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
    }
    public function getRejectedTaskDetails()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $result = $this->TaskModel->getRejectedTaskDetails($hash);
        if ($result) {
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'عرض الواجب',
                    'token' => $token,
                    'data' => $result,
                    'isAuth' => true,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        } else {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء عرض الواجب',
                    'token' => $token,
                    'isAuth' => true,
                    'hash' => $hash,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
    }

    public function create()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);
        $user_hash = $user['hash'];
        $direct_task = $this->input->post('direct_task') ?? 0;



        // Get data from the user input
        $attachments = $this->input->post('attachment');
        // delete [] from the array
        $attachments = substr($attachments, 1, -1);
        // explode the array
        $attachments = explode(',', $attachments);
        $receiverJson = $this->input->post('receiver');
        $hash = $this->jwtmiddleware->createHash();
        $data = array(
            'hash' => $hash,
            'title' => $this->input->post('title'),
            'discription' => $this->input->post('discription'),
            'start_task' => $this->input->post('start_task'),
            'deadline' => $this->input->post('deadline'),
            'score' => $this->input->post('score'),
            'emergency' => $this->input->post('emergency'),
            'status' => $this->input->post('status') ?? '111',
            'project_hash' => $this->input->post('project_hash'),
            'sender' => $user_hash,
            'receiver' => json_decode($receiverJson, true),
            'note' => $this->input->post('note'),
            'attachments' => $attachments,
            'created_at' => date('Y-m-d H:i:s'),
            'updated_at' => date('Y-m-d H:i:s'),
            'send_date' => date('Y-m-d H:i:s'),
            'minutes_deadline' => $this->input->post('minutes_deadline'),
            'is_simple' => $this->input->post('is_simple'),
            'phone_num' => $this->input->post('phone_num'),
            'task_name_subscriber' => $this->input->post('task_name_subscriber'),
            'lat' => $this->input->post('lat') ?? NULL,
            'lng' => $this->input->post('lng') ?? NULL,
        );
        if ($direct_task == 1) {
            $data['direct_task'] = $direct_task;
        }
        // Call the create task function in the model
        $result = $this->TaskModel->add($data);


        if (is_string($result)) {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => $result,
                    'token' => $token,
                    'isAuth' => true,
                    'aciton' => true,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
        if ($data['is_simple'] == 0) {
            $this->TaskModel->insertScheduler($data);
        }
        if ($result) {
            foreach ($data['receiver'] as $receiver) {
                $this->jwtmiddleware->insertNotToFirebase([
                    "type" => "task",
                    "status" => 'create',
                    "user" => $user_hash,
                    'receiver' => $receiver,
                ]);
                $receiver_name = $this->UserModel->getUserName($receiver);
                $user_name = $this->UserModel->getUserName($user_hash);
                $this->jwtmiddleware->sendNot(
                    'تم إنشاء واجب جديد',
                    json_encode(array('type' => 10, 'key' => $hash)),
                    $this->UserModel->getMobileToken($receiver),
                    'تم إنشاء واجب جديد بعنوان ' . $this->input->post('title') .
                    ' قام ' . $user_name . ' بإسناد واجب جديد إلى ' . $receiver_name
                );
            }
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'تم إنشاء الواجب بنجاح',
                    'token' => $token,
                    'data' => $result,
                    'isAuth' => true,
                    'action' => true,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        } else {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء إنشاء الواجب',
                    'token' => $token,
                    'isAuth' => true,
                    "attachments" => $attachments,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
    }

    public function update()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];

        $receiverJson = $this->input->post('receiver');

        $hash = $this->input->post('hash');
        $data = array(
            'title' => $this->input->post('title'),
            'discription' => $this->input->post('discription'),
            'start_task' => $this->input->post('start_task'),
            'deadline' => $this->input->post('deadline'),
            'sender' => $user,
            'emergency' => $this->input->post('emergency'),
            'score' => $this->input->post('score'),
            'receiver' => json_decode($receiverJson, true),
            'status' => $this->input->post('status'),
            'project_hash' => $this->input->post('project_hash'),
            'updated_at' => date('Y-m-d H:i:s'),
            'is_simple' => $this->input->post('is_simple'),
            'minutes_deadline' => $this->input->post('minutes_deadline'),
            'task_name_subscriber' => $this->input->post('task_name_subscriber'),
            'phone_num' => $this->input->post('phone_num'),

        );
        $result = $this->TaskModel->update($hash, $data);
        if (is_string($result)) {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => $result,
                    'token' => $token,
                    'isAuth' => true,
                    'action' => true,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم تعديل الواجب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function delete()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];

        $hash = $this->input->post('hash');
        $project_hash = $this->input->post('project_hash');
        $is_simple = $this->input->post('is_simple') ?? '';

        $result = $this->TaskModel->delete($hash, $user, $is_simple);
        if (is_string($result)) {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => $result,
                    'token' => $token,
                    'isAuth' => true,
                    'action' => true,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'تم حذف الواجب بنجاح',
                'token' => $token,
                'isAuth' => true,
                'action' => true,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function changeStatus()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $taskHash = $this->input->post('hash');
        $status = $this->input->post('status');
        //  this indicate to note user insert after change status (accept , denied)
        $action_note = $this->input->post('action_note');

        // Get data from the user input
        $attachments = $this->input->post('attachment');
        // delete [] from the array
        $attachments = substr($attachments, 1, -1);
        // explode the array
        $attachments = explode(',', $attachments);

        $result = $this->TaskModel->changeStatus($taskHash, $status, $action_note, $attachments);
        $task = $this->TaskModel->get($taskHash);
        if ($result) {
            $this->jwtmiddleware->sendNot(
                "تم تغيير حالة الواجب الخاص بك الي " . $task->title_status,
                json_encode(array('type' => 4)),
                $this->UserModel->getMobileToken($task->sender),
                "تم تغيير حالة الواجب الخاص بك بعنوان " . $task->title . " إلى " . $task->title_status . " من قبل " . $user['name'],
            );
            $this->jwtmiddleware->insertNotToFirebase([
                "type" => "task",
                "status" => 'status',
                "user" => $user['hash'],
                'receiver' => $task->accept_user,
                'status_title' => $task->title_status,
            ]);
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'تم تغيير حالة الواجب بنجاح',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => true,
                    'data' => $result,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        } else {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء تغيير حالة الواجب',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => false,
                    'data' => $result,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
    }

    public function resetTaskStatus()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];
        $name = $this->jwtmiddleware->decode($token)['name'];

        $taskHash = $this->input->post('hash');
        $projectHash = $this->input->post('project_hash');
        $is_simple = $this->input->post('is_simple') ?? '';
        $getRejectedUserOrAcceptByHash = $this->TaskModel->getRejectedUserOrAcceptByHash($taskHash);
        $reciever = null;
        $recieversJson = $this->input->post('receiver');
        $recievers = json_decode($recieversJson, true);

        if ($getRejectedUserOrAcceptByHash) {
            $reciever = $getRejectedUserOrAcceptByHash->accept_user ?? $getRejectedUserOrAcceptByHash->rejected_user;
        }

        $data = array(
            'taskHash' => $taskHash,
            'projectHash' => $projectHash,
            'user' => $user,
            'is_simple' => $is_simple,
            'recievers' => $recievers,
        );
        $result = $this->TaskModel->resetTaskStatus($data);

        if (is_string($result)) {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => $result,
                    'token' => $token,
                    'isAuth' => true,
                    'action' => false,
                    'data' => $result,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }

        if ($result) {

            $this->jwtmiddleware->sendNot(
                "تم إعادة إرسال الواجب الخاص بك بعنوان " . $result->title,
                json_encode(array('type' => 3)),
                $this->UserModel->getMobileToken($reciever),
                "تم إعادة إرسال الواجب بعنوان " . $result->title . " من قبل " . $name,
            );

            $this->jwtmiddleware->insertNotToFirebase([
                "type" => "task",
                "status" => 'resend', // Update to 'resend' to reflect the resend status
                "user" => $user,
                'receiver' => $reciever ?? $result->accept_user ?? $result->rejected_user ?? null,
                'status_title' => "إعادة إرسال", // Optional, you could change this to reflect "Resend" as well
            ]);

            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'تم اعاده ارسال الواجب بنجاح',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => true,
                    'data' => $result,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        } else {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء اعاده ارسال الواجب',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => false,
                    'data' => $result,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
    }

    public function deleteAttachment()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $details = $this->TaskModel->deleteAttachment($hash);

        if ($details == 1) {
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'تم حذف مرفقات الواجب بنجاح',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => true,
                    'data' => $details,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        } else {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'تأكد من كود المرفقات او الواجب، أحدهما خاطئ',
                    'token' => $token,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
    }

    public function getCurrentUserTasks()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $user['hash'];

        $tasks = $this->TaskModel->getCurrentUserTasks($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'واجبات المستخدم',
                'token' => $token,
                'isAuth' => true,
                'action' => false,
                'data' => $tasks,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getCurrentUserTasksHistory()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $user['hash'];

        $tasks = $this->TaskModel->getCurrentUserTasksHistory($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'واجبات المستخدم',
                'token' => $token,
                'isAuth' => true,
                'action' => false,
                'data' => $tasks,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function receivedTasks()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $user['hash'];

        $tasks = $this->TaskModel->receivedTasks($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'واجبات المستخدم',
                'token' => $token,
                'isAuth' => true,
                'action' => false,
                'data' => $tasks,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function sendedTasks()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $user['hash'];

        $tasks = $this->TaskModel->sendedTasks($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'واجبات المستخدم',
                'token' => $token,
                'isAuth' => true,
                'action' => false,
                'data' => $tasks,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function getAttachments()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');

        $tasks = $this->TaskModel->getAttachments($hash);
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'المرفقات',
                'token' => $token,
                'isAuth' => true,
                'action' => false,
                'data' => $tasks,
                'hash' => $hash,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function status()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $tasks = $this->TaskModel->getStatus();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'حالات الواجبات',
                'token' => $token,
                'isAuth' => true,
                'action' => false,
                'data' => $tasks,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function changeEmergency()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $emergency = $this->input->post('status');
        $task = $this->TaskModel->get($hash);
        $result = $this->TaskModel->changeEmergency($hash, $emergency);

        if ($result) {
            $this->jwtmiddleware->insertNotToFirebase([
                "type" => "task",
                "status" => 'emergency',
                "user" => $user['hash'],
                'receiver' => $task->sender,
                'emergency' => $emergency,
            ]);
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'تم تغيير حالة الاولوية',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => false,
                    'data' => $result,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        } else {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء تغيير الاولوية',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => false,
                    'data' => $result,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
        exit();
    }

    public function changeIsAccept()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $isaccept = $this->input->post('isAccept');
        $note = $this->input->post('note');
        $sender = $this->input->post('sender');
        $result = $this->TaskModel->changeIsAccept($hash, $isaccept, $note, $user['hash']);
        if ($result) {
            $task = $this->TaskModel->get($hash);
            if ($isaccept == 0) {
                $this->jwtmiddleware->sendNot(
                    "تم رفض واجب $task->title",
                    json_encode(array('type' => 0)),
                    $this->UserModel->getMobileToken($sender),
                    'تم رفض الواجب بسبب : ' . $note
                );
            }
            $this->jwtmiddleware->insertNotToFirebase([
                "type" => "task",
                "status" => 'accept',
                "user" => $user['hash'],
                'receiver' => $task->sender,
                'isaccept' => $isaccept,
            ]);
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'تم تغيير الحالة ',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => true,
                    'data' => $result,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        } else {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء تغيير الحالة',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => false,
                    'data' => array(
                        'hash' => $hash,
                        'isaccept' => $isaccept,
                        'note' => $note,
                    ),
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
        exit();
    }

    public function allEmployeesListIncludeCurrentUser()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $employees = $this->TaskModel->allEmployeesListIncludeCurrentUser();
        echo json_encode(
            array(
                'status' => 200,
                'message' => 'حالات الواجبات',
                'token' => $token,
                'isAuth' => true,
                'action' => false,
                'data' => $employees,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function user_current_tasks()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $tasks = $this->TaskModel->getCurrentUserTasks($hash, 5);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'واجبات المستخدم',
                'token' => $token,
                'isAuth' => true,
                'action' => false,
                'data' => $tasks,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function user_finished_tasks()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->get('hash');
        $tasks = $this->TaskModel->userTasks($hash, 2);

        echo json_encode(
            array(
                'status' => 200,
                'message' => 'واجبات المستخدم',
                'token' => $token,
                'isAuth' => true,
                'action' => false,
                'data' => $tasks,
            ),
            JSON_UNESCAPED_UNICODE
        );
        exit();
    }

    public function changeReceiver()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token);

        $hash = $this->input->post('hash');
        $receiver = $this->input->post('receiver');
        // check if receiver and hash is exist from client
        if (!$hash || !$receiver) {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'الرجاء إدخال البيانات المطلوبة',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => false,
                    'data' => array(
                        'hash' => $hash ? $hash : 'مطلوب',
                        'receiver' => $receiver ? $receiver : 'مطلوب',
                    ),
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }

        $result = $this->TaskModel->changeReceiver($hash, $receiver);

        if ($result) {
            $this->jwtmiddleware->sendNot(
                "تم اسناد واجب جديد لك",
                json_encode(array('type' => 3)),
                $this->UserModel->getMobileToken($receiver),
                'تم اسناد واجب جديد لك يجب عليك الاطلاع عليه والموافقة عليه او رفضه'
            );
            $this->jwtmiddleware->insertNotToFirebase([
                "type" => "task",
                "status" => 'receiver',
                "user" => $user['hash'],
                'receiver' => $receiver,
            ]);
            echo json_encode(
                array(
                    'status' => 200,
                    'message' => 'تم تغيير المستلم',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => true,
                    'data' => $result,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        } else {
            echo json_encode(
                array(
                    'status' => 400,
                    'message' => 'حدث خطأ أثناء تغيير المستلم',
                    'token' => $token,
                    'isAuth' => true,
                    'action' => false,
                    'data' => $result,
                ),
                JSON_UNESCAPED_UNICODE
            );
            exit();
        }
        exit();
    }
}
