<?php
defined('BASEPATH') or exit('No direct script access allowed');

class TaskChartController extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->model('TaskChartModel');
        $this->load->model('UserModel');
        $this->load->library('Middleware');

    }

    public function taskCompletionDetails()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];
        $result = $this->TaskChartModel->getTaskCompletionDetails($user);
        if ($result) {
            $this->sendResponse(200, $result, 'Data found');
        } else {
            $this->sendResponse(400, 'No data found');
        }

    }

    public function taskChartPie()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];
        $project_hash = $this->input->get('project_hash') ?? null;

        $user_hash = $this->input->get('user_hash') ?? null;
        $start_date = $this->input->get('start_date') ?? null;
        $end_date = $this->input->get('end_date') ?? null;
        $result = $this->TaskChartModel->getTaskChartPie($project_hash, $user_hash, $start_date, $end_date, $user);

        if ($result) {
            $this->sendResponse(200, $result, 'Data found');
        } else {
            $this->sendResponse(200, [], 'No data found');
        }

    }

    public function taskChartData()
    {
        $token = $this->tokenmiddleware->main();
        $this->UserModel->checkPermission();
        $user = $this->jwtmiddleware->decode($token)['hash'];
        $project_hash = $this->input->get('project_hash');
        $user_hash = $this->input->get('user_hash') ?? '';
        $start_date = $this->input->get('start_date') ?? '';
        $end_date = $this->input->get('end_date') ?? '';
        $data = $this->TaskChartModel->getTaskChartData($project_hash, $user_hash, $start_date, $end_date, $user);

        if ($data) {
            $this->sendResponse(200, $data, 'Data found');
        } else {
            $this->sendResponse(200, [], 'No data found');
        }
    }

    private function sendResponse($status, $data, $message = null)
    {
        echo json_encode(array('status' => $status, 'data' => $data, 'message' => $message, 'isAuth' => true), JSON_UNESCAPED_UNICODE);
        exit();
    }
}