<?php
require __DIR__ . '/jwt/autoload.php';
// require __DIR__ . '/vendor/autoload.php';

use Firebase\JWT\JWT;
use Firebase\JWT\Key;


require 'vendor/autoload.php';
use Google\Client;
$serviceAccountPath = __DIR__ . '/zone-hr.json'; // Assuming the file is in the same directory
$projectId = 'zone-hr';

// fire base from vender google firebase

class JwtMiddleware
{

    private $secret_key;

    public function __construct()
    {
        $this->secret_key = '@@redhaalasd2020@@';
        // load model
        $this->CI = &get_instance();
        $this->CI->load->model('NotificationModel');
        $this->CI->load->model('UserModel');

    }

    public function encode($data, $expir = "11900")
    {
        $iat = time();
        $exp = $iat + $expir;
        $data["iat"] = $iat;
        $data["exp"] = $exp;
        $payload = $data;
        $jwt = JWT::encode($payload, $this->secret_key, 'HS256');
        return $jwt;
    }

    public function decode($token, $type = "normal")
    {
        try {
            $decoded = JWT::decode($token, new Key($this->secret_key, 'HS256'));
            $decoded_array = (array) $decoded;
            $exp = $decoded_array["exp"];
            $iat = time();
            if ($exp > $iat || $type == "logout") {
                return $decoded_array;
            } else {
                return 0;
            }

        } catch (Exception $e) {
            return 0;
        }
    }

    public function createHash()
    {
        // hash == 16 number
        $hash = rand(1000000000000000, 9999999999999999);
        return $hash;
    }

    public function get_current_user_hash()
    {
        $headers = apache_request_headers();
        if (isset($headers['Authorization'])) {
            $authHeader = $headers['Authorization'];
            list($jwt) = sscanf($authHeader, 'Bearer %s');

            if ($jwt) {
                try {
                    $decoded = JWT::decode($jwt, new Key($this->secret_key, 'HS256'));
                    return $decoded->hash;
                } catch (Exception $e) {
                    return false;
                }
            }
        }

        return false;
    }

    // public function sendNot($title, $data, $token, $message)
    // {
    //     $curl = curl_init();

    //     curl_setopt_array(
    //         $curl,
    //         array(
    //             CURLOPT_URL => "https://fcm.googleapis.com/fcm/send",
    //             CURLOPT_RETURNTRANSFER => true,
    //             CURLOPT_ENCODING => "",
    //             CURLOPT_MAXREDIRS => 10,
    //             CURLOPT_TIMEOUT => 30,
    //             CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    //             CURLOPT_CUSTOMREQUEST => "POST",
    //             CURLOPT_POSTFIELDS => "{\r\n    \"notification\": {\r\n        \"body\": \"$message\",\r\n        \"title\": \"$title\",\r\n        \"sound\": \"default\"\r\n    },\r\n    \"data\": $data,\r\n    \"priority\": \"high\",\r\n    \"to\": \"$token\"\r\n}",
    //             CURLOPT_HTTPHEADER => array(
    //                 "authorization: key=AAAA4ECzuAU:APA91bHN1yjQNmJ4ICjJnw15gaoYutHglQRrLzwT8wGuNKayK6cyorFEAvYgyyKiv-y2pp0Js4oLwwxSbKdb4rV2tEix8Jke69c1g1CcZbZ1f7TyDMUhT0VspWvGawOzgrzrjFBBpZa7",
    //                 "cache-control: no-cache",
    //                 "content-type: application/json",
    //                 "postman-token: 3c0e79f3-97eb-0024-022c-7adb8d94e7e5",
    //             ),
    //         )
    //     );
    //     $response = curl_exec($curl);
    //     $err = curl_error($curl);
    //     curl_close($curl);
    //     if ($err) {
    //         echo false;
    //     } else {
    //         return true;
    //     }
    // }

    public function sendNot($title, $data, $token, $body) {
        // Decode the JSON-encoded $data to an associative array
        $decodedData = json_decode($data, true);
    
        // Prepare the message array with the decoded data
        $message = [
            'token' => $token,
            'notification' => [
                'title' => $title,
                'body' => $body,
            ],
            'data' => $decodedData, // Use the decoded data here
        ];
    
        global $serviceAccountPath;
        $accessToken = getAccessToken($serviceAccountPath);
    
        global $projectId;
        $url = 'https://fcm.googleapis.com/v1/projects/' . $projectId . '/messages:send';
        $headers = [
            'Authorization: Bearer ' . $accessToken,
            'Content-Type: application/json',
        ];
    
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode(['message' => $message]));
        $response = curl_exec($ch);
    
        if ($response === false) {
            throw new Exception('Curl error: ' . curl_error($ch));
        }
    
        curl_close($ch);
        return json_decode($response, true);
    }


    public function sendToMapNot()
    {
        $curl = curl_init();

        curl_setopt_array(
            $curl,
            array(
                CURLOPT_URL => "https://fcm.googleapis.com/fcm/send",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 30,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => "{\r\n\"priority\": \"high\",\r\n\"condition\": \"'test' in topics\"\r\n}",
                CURLOPT_HTTPHEADER => array(
                    "authorization: key=AAAA4ECzuAU:APA91bHN1yjQNmJ4ICjJnw15gaoYutHglQRrLzwT8wGuNKayK6cyorFEAvYgyyKiv-y2pp0Js4oLwwxSbKdb4rV2tEix8Jke69c1g1CcZbZ1f7TyDMUhT0VspWvGawOzgrzrjFBBpZa7",
                    "cache-control: no-cache",
                    "content-type: application/json",
                    "postman-token: 3c0e79f3-97eb-0024-022c-7adb8d94e7e5",
                ),
            )
        );
        $response = curl_exec($curl);
        $err = curl_error($curl);
        curl_close($curl);
        if ($err) {
            echo false;
        } else {
            return true;
        }
    }

    public function insertNotToFirebase($data)
    {
        $type = $data["type"];
        $user_hash = $data["user"];
        $user_name = $this->CI->UserModel->getUserName($user_hash);
        $title = "";
        $text = "";
        switch ($type) {
            case 'task':
                $receiver = $data["receiver"];
                $receiver_name = $this->CI->UserModel->getUserName($receiver);
                $status = $data["status"];
                switch ($status) {
                    case 'create':
                        $title = "???? ????";
                        $text = "??? $user_name ?????? ???? ???? ??? $receiver_name";
                        break;
                    case 'status':
                        $status_title = $data["status_title"];
                        $title = "???? ???? ????";
                        if ($receiver_name == $user_name) {
                            $text = "??? $user_name ????? ???? ?????? ????? ?? ??? $status_title";
                        } else {
                            $text = "??? $user_name ????? ???? ?????? ????? ? $receiver_name ??? $status_title";
                        }

                        break;
                    case 'emergency':
                        $emergency = $data["emergency"];
                        if ($emergency == "1") {
                            $title = "???? ?? ??????";
                            $text = "??? $user_name ?????? ?????? ????? ? $receiver_name ??? ???? ?? ??????";
                        } else {
                            $title = "???? ??? ??????";
                            $text = "??? $user_name ?????? ?????? ????? ? $receiver_name ??? ???? ??? ??????";
                        }
                    case 'accept':
                        $isaccept = $data["isaccept"];
                        if ($isaccept == "1") {
                            $title = "???? ????";
                            $text = "??? $user_name ????? ?????? ????? ? $receiver_name";
                        } else {
                            $title = "??? ????";
                            $text = "??? $user_name ???? ?????? ????? ? $receiver_name";
                        }
                        break;
                    case 'receiver':
                        $title = "???? ????? ??????";
                        $text = "??? $user_name ????? ????? ?????? ????? ?? ??? $receiver_name";
                        break;
                    default:
                        // code...
                        break;
                }
                break;
            case 'fingerPrint':
                $status = $data["status"];
                $title = "????? ????";
                if ($status == "in") {
                    $text = "??? $user_name ???? ???? ????";
                } else {
                    $text = "??? $user_name ???? ???? ????";
                }

                break;
            case 'check_in':
                $title = "????? ????";
                $note = $data["note"];
                $text = "??? $user_name ?????? ????? ??????? $note";
                break;
            case 'vacation':
                $status = $data["status"];
                $receiver = $data["receiver"];
                $receiver_name = $this->CI->UserModel->getUserName($receiver);
                switch ($status) {
                    case 'request':
                        $title = "??? ?????";
                        $text = "??? $user_name ???? ????? ?? $receiver_name";
                        break;
                    case '111':
                        $title = "??? ???????? ??? ?????";
                        $text = "??? ???????? ??? ????? $receiver_name ?? ??? $user_name";
                        break;
                    case '222':
                        $title = "?? ??? ?????";
                        $text = "?? ??? ????? $receiver_name ?? ??? $user_name";
                        break;
                    case '333':
                        $title = "?? ????? ?????";
                        $text = "?? ????? ????? ??? $receiver_name ?? ??? $user_name";
                        break;
                    default:
                        break;
                }
                break;
            case 'advance':
                $status = $data["status"];
                $receiver = $data["receiver"];
                $receiver_name = $this->CI->UserModel->getUserName($receiver);
                switch ($status) {
                    case 'request':
                        $title = "??? ????";
                        $text = "??? $user_name ???? ???? ?? $receiver_name";
                        break;
                    case '1':
                        $title = "??? ???????? ??? ????";
                        $text = "??? ???????? ??? ???? $receiver_name ?? ??? $user_name";
                        break;
                    case '2':
                        $title = "?? ??? ????";
                        $text = "?? ??? ???? $receiver_name ?? ??? $user_name";
                        break;
                    case '3':
                        $title = "?? ????? ????";
                        $text = "?? ????? ???? ??? $receiver_name ?? ??? $user_name";
                        break;
                    default:
                        break;
                }
                break;
            case 'not_connected':
                $message = $data["message"];
                $receiver = $data["receiver"];
                $receiver_name = $this->CI->UserModel->getUserName($receiver);

                $title = "??? ???? ????????";
                $text = "??? $user_name ????? ??? $receiver_name  $message";
                // $text = $message ;
                break;
            default:
                # code...
                break;
        }
        $curl = curl_init();
        if ($text != "" && $title != "") {
            $this->CI->NotificationModel->createNotification($title, $type, $text, $user_hash);
            $post_fields = [
                "key" => "rN9yNrQ7AUNys9mEsi0YLYuLIsaVSmJJvGzl7PMA",
                "secret" => "hcRnzwTKoBLGri6AJS7TQLXVT65GChiY",
                "roomId" => 'spaceLight',
                "message" => ["type" => $type],
            ];
            curl_setopt_array(
                $curl,
                array(
                    CURLOPT_URL => "https://s9272.fra1.piesocket.com/api/publish",
                    CURLOPT_RETURNTRANSFER => true,
                    CURLOPT_CUSTOMREQUEST => "POST",
                    CURLOPT_POSTFIELDS => json_encode($post_fields),
                    CURLOPT_HTTPHEADER => array(
                        "Content-Type: application/json",
                    ),
                )
            );

            $response = curl_exec($curl);
            return $response;
        } else {
            return 0;
        }

    }
}
