<?php

class AcceptanceJourneyModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    // get all Groups
    public function count_records()
    {
        $headers = apache_request_headers();
        $search = $this->input->get('q') ?? '';
        $this->db->select('count(*) as count');
        $this->db->from('account_registeration');
        if ($search) {
            $this->db->like('name', $search);
        }
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }

    public function all()
    {
        // get page and limit and search from header
        $headers = apache_request_headers();
        $page = $headers['page'] ?? $this->input->get('page') ?? 1;
        $perPage = $headers['perPage'] ?? $this->input->get('perPage') ?? 10;
        $offset = ($page - 1) * $perPage;

        $this->db->select(
            'accept_journy.*, accept_journy_status.name AS status_name'
        );
        $this->db->from('accept_journy');
        $this->db->join('accept_journy_status', 'accept_journy.status = accept_journy_status.id');

        // order by
        $this->db->order_by('id', 'DESC');
        // limit
        $this->db->limit($perPage, $offset);
        $query = $this->db->get();

        return $query->result_array();
    }

    public function getTypes()
    {
        $this->db->select('id AS value, name AS label');
        $this->db->from('account_registeration_types');
        $query = $this->db->get();
        return $query->result_array();
    }

    function getAccount($hash)
    {
        $this->db->select('account_registeration.*, accounting_tree.name AS name');
        $this->db->from('account_registeration');
        $this->db->join('accounting_tree', 'accounting_tree.id = account_registeration.account');
        $this->db->where('account_registeration.hash =', $hash);
        $query = $this->db->get();

        $result = $query->result_array();
        return $result;
    }

    function add($data)
    {
        $this->db->insert('accept_journy', $data);
        return $this->db->insert_id();
    }

    function updateAccount($data)
    {
        $this->db->where('hash', $data['hash']);
        $this->db->update('account_registeration', $data);
        return $this->db->affected_rows();
    }

    function deleteAccount($hash)
    {
        $this->db->where('hash', $hash);
        $this->db->delete('account_registeration');
        return $this->db->affected_rows();
    }
}
