<?php
class AdvanceModal extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->load->model('UserModel');
        $this->load->library('Middleware');

    }



    public function count()
    {
        $this->db->select("system_users.name as name, system_users.image_profile ");
        $this->db->select("partments.name as department");
        $this->db->select("system_group_name.name as jop");
        $this->db->select("
    DATE(advance.date) as date,
    TIME_FORMAT(TIME(advance.date), '%l:%i %p') as time,
    advance.id, 
    advance.user_hash,
    advance.price
");
        $this->db->select("(SELECT name FROM advance_status WHERE id = advance_steps.status_id) AS status");
        $this->db->select("advance_steps.user_admin");
        $this->db->from('advance');
        $this->db->join('system_users', 'system_users.hash = advance.user_hash', 'left');
        $this->db->join('emp_information', 'emp_information.user_hash = advance.user_hash', 'left');
        $this->db->join('partments', 'partments.hash = emp_information.partment', 'left');
        $this->db->join('system_group_name', 'system_group_name.hash = system_users.user_type', 'left');
        $this->db->join('advance_steps', 'advance_steps.id = (SELECT id FROM advance_steps WHERE advance_steps.advance_id = advance.id ORDER BY id DESC LIMIT 1)', 'left');
        $this->db->where('advance.is_deleted', 0);

        // Count the total number of records
        $total_records = $this->db->count_all_results();

        return $total_records;
    }

    public function getCount($start, $end)
    {
        $headers = apache_request_headers();
        $search = $headers['q'] ?? '';
        $department = $this->input->get('department') ?? "";
        $this->db->select('count(*) as count');
        $this->db->from('advance');
        $this->db->join('emp_information', 'emp_information.user_hash = advance.user_hash', 'left');
        // where
        if (isset($start) && $start != "" && $start != 'null') {
            $this->db->where('DATE(date) >=', $start);
        }
        if (isset($end) && $end != "" && $end != 'null') {
            $this->db->where('DATE(date) <=', $end);
        }
        if (isset($search) && $search != "" && $search != 'null') {
            $this->db->where('advance.user_hash', $search);
        }
        if (isset($department) && $department != "" && $department != 'null') {
            $this->db->where('emp_information.partment', $department);
        }
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }

    public function getDistinctUserHashCount()
    {
        $this->db->select('COUNT(DISTINCT advance.user_hash) as distinct_user_hash_count');
        $this->db->from('advance');
        $this->db->join('system_users', 'system_users.hash = advance.user_hash', 'left');
        $this->db->join('emp_information', 'emp_information.user_hash = advance.user_hash', 'left');
        $this->db->join('partments', 'partments.hash = emp_information.partment', 'left');



        // Add any additional conditions or joins as needed

        $query = $this->db->get();
        return $query->row()->distinct_user_hash_count;
    }

    public function getHistoryOfAdvance($hash)
    {
        $query = $this->db->query("
        SELECT
    advance.id AS 'id',
    advance.user_hash AS 'user_hash',
    advance.user_admin as 'user_admin',
    advance.date AS 'date',
    advance.price AS 'price',
    advance_steps.notes AS 'notes',
    (SELECT name FROM system_users WHERE system_users.hash = advance.user_hash) AS name,
    (SELECT name FROM advance_status WHERE advance_status.id = advance_steps.status_id) AS status,
    
    (SELECT name FROM advance_status WHERE advance_status.id = 
        (SELECT status_id FROM advance_steps b WHERE b.advance_id = advance.id ORDER BY date DESC LIMIT 1)
    ) AS final_status
FROM
    advance
JOIN advance_steps ON advance.id = advance_steps.advance_id
WHERE
    advance_steps.user_hash = '{$hash}'
    AND advance_steps.status_id IN ('1', '2', '3')
ORDER BY
    advance.id DESC;
        ");
        return $query->result_array();

    }

    public function getAll($start, $end)
    {
        $headers = apache_request_headers();

        $isWork = $this->input->get('iswork');
        $department = $this->input->get('department') ?? '';
        $page = $this->input->get('page') ?? '1';
        $perPage = $this->input->get('perPage') ?? '10';
        $start = $this->input->get('start');
        $end = $this->input->get('end');

        if (!isset($isWork) || $isWork !== '2') {
            $isWork = '2';
        } else {
            $isWork = '1';
        }
        $search = $this->input->get('q') ?? '';
        $offset = ($page - 1) * $perPage;

        $this->db->select("system_users.name as name, system_users.image_profile ");
        $this->db->select("partments.name as department");
        $this->db->select("system_group_name.name as jop");
        $this->db->select("
            DATE(advance.date) as date,
            TIME_FORMAT(TIME(advance.date), '%l:%i %p') as time,
            advance.id, 
            advance.user_hash,
            advance.price,
            advance_steps.notes
        ");
        $this->db->select("(SELECT name FROM advance_status WHERE id = advance_steps.status_id) AS status");
        $this->db->select("advance_steps.user_admin");
        $this->db->from('advance');
        $this->db->join('system_users', 'system_users.hash = advance.user_hash', 'left');
        $this->db->join('emp_information', 'emp_information.user_hash = advance.user_hash', 'left');
        $this->db->join('partments', 'partments.hash = emp_information.partment', 'left');
        $this->db->join('system_group_name', 'system_group_name.hash = system_users.user_type', 'left');
        // join only max id advance_steps
        $this->db->join('advance_steps', 'advance_steps.id = (SELECT id FROM advance_steps WHERE advance_steps.advance_id = advance.id ORDER BY id DESC LIMIT 1)', 'left');
        $this->db->where('advance.is_deleted', 0);
        // Where
        if (isset($start) && $start != "" && $start != 'null') {
            $this->db->where('DATE(advance.date) >=', $start);
        }
        if (isset($end) && $end != "" && $end != 'null') {
            $this->db->where('DATE(advance.date) <=', $end);
        }
        // Search
        if (isset($search) && $search != 'null' && $search != '') {
            $this->db->group_start();
            $this->db->like('system_users.name', $search);
            $this->db->or_like('username', $search);
            $this->db->group_end();
        }
        if (isset($department) && $department != "" && $department != 'null') {
            $this->db->where('emp_information.partment', $department);
        }
        // Order by
        $this->db->order_by('advance.id DESC');
        // Limit
        $this->db->limit($perPage, $offset);
        $query = $this->db->get();
        return $query->result_array();
    }

    public function getAdvance($id)
    {
        $this->db->select("system_users.name as name, system_users.image_profile as image_profile");
        $this->db->select("partments.name as department");
        $this->db->select("system_group_name.name as jop");
        $this->db->select("
            DATE(advance.date) as date,
            TIME_FORMAT(TIME(advance.date), '%l:%i %p') as time,
            advance.id, 
            advance.user_hash,
            advance.price,
            advance_steps.notes
        ");
        $this->db->select("(SELECT name FROM advance_status WHERE id = advance_steps.status_id) AS status");
        $this->db->select("advance_steps.user_admin");
        $this->db->from('advance');
        $this->db->join('system_users', 'system_users.hash = advance.user_hash', 'left');
        $this->db->join('emp_information', 'emp_information.user_hash = advance.user_hash', 'left');
        $this->db->join('partments', 'partments.hash = emp_information.partment', 'left');
        $this->db->join('system_group_name', 'system_group_name.hash = system_users.user_type', 'left');
        // join only max id advance_steps
        $this->db->join('advance_steps', 'advance_steps.id = (SELECT id FROM advance_steps WHERE advance_steps.advance_id = advance.id ORDER BY id DESC LIMIT 1)', 'left');
        $this->db->where('advance.is_deleted', 0);
        $this->db->where('advance.id', $id);
        $query = $this->db->get();
        return $query->row_array();
    }

    public function getMyAdvances($user_hash, $type = "requests")
    {
        $this->db->select("system_users.name as name, system_users.image_profile");
        $this->db->select("partments.name as department");
        $this->db->select("system_group_name.name as jop");
        $this->db->select("
            DATE(advance.date) as date,
            TIME_FORMAT(TIME(advance.date), '%l:%i %p') as time,
            advance.id,     
            advance.user_hash,
            advance.price,
            advance_steps.notes
        ");

        $this->db->select("(SELECT name FROM advance_status WHERE id = advance_steps.status_id) AS status");
        $this->db->select("advance_steps.user_admin");
        $this->db->from('advance');
        $this->db->join('system_users', 'system_users.hash = advance.user_hash', 'left');
        $this->db->join('emp_information', 'emp_information.user_hash = advance.user_hash', 'left');
        $this->db->join('partments', 'partments.hash = emp_information.partment', 'left');
        $this->db->join('system_group_name', 'system_group_name.hash = system_users.user_type', 'left');

        // join only max id advance_steps
        $this->db->join('advance_steps', 'advance_steps.id = (SELECT id FROM advance_steps WHERE advance_steps.advance_id = advance.id ORDER BY id DESC LIMIT 1)', 'left');
        $this->db->where('advance.is_deleted', 0);

        if ($type == "requests") {
            $this->db->where('advance.user_hash', $user_hash);
        } else if ($type == "agreements") {
            $this->db->where('advance_steps.user_admin', $user_hash);
            // is not finish
            $this->db->where('advance_steps.is_finish', 0);
        }
        // group by advance.id
        $this->db->group_by('advance.id');
        $this->db->order_by("advance.id", "DESC");
        $query = $this->db->get();

        return $query->result_array();
    }

    public function create($data)
    {
        $notes = $data['notes'];
        $user_hash = $data['user_hash'];
        $user_admin = $data['user_admin'];
        // cuz this column not created on advance
        unset($data['notes']);

        if ($this->canCreateAdvanceRequest($user_hash) == 1) {

            $this->db->insert('advance', $data);
            $id = $this->db->insert_id();

            $this->createStep([
                'advance_id' => $id,
                "notes" => $notes,
                "user_hash" => $user_hash,
                "user_admin" => $user_admin
            ]);

            return $id;
        } else {
            return "ليس لديك صلاحه لطلب سلفه";
        }
    }

    private function canCreateAdvanceRequest($userId)
    {
        // Query the database to check if the flag allows creating advance requests for the user
        $userInfo = $this->db->where('user_hash', $userId)->get('emp_information')->row();

        return ($userInfo && $userInfo->advance_request == 1);
    }
    private function canAgreeAdvanceRequest($userId)
    {
        // Query the database to check if the flag allows creating advance requests for the user
        $userInfo = $this->db->where('user_hash', $userId)->get('emp_information')->row();

        return ($userInfo && $userInfo->advance_agreement == 1);
    }

    public function delete($id)
    {
        $this->db->where('id', $id);
        $this->db->update('advance', ['is_deleted' => 1]);
    }
    public function getStatus($id)
    {
        $query = $this->db->query("
            SELECT 
                (SELECT name FROM advance_status WHERE id = advance.status_id) AS status 
            FROM advance_steps WHERE advance_id = $id ORDER BY id DESC LIMIT 1
        ");
        return $query->row_array()['status'];
    }

    public function getAdmin($id)
    {
        $query = $this->db->query("
            SELECT 
                (SELECT name FROM system_users WHERE id = advance_steps.user_admin) AS admin 
            FROM advance_steps WHERE advance_id = $id ORDER BY id DESC LIMIT 1
        ");
        return $query->row_array()['admin'];
    }



    public function getSteps($id)
    {
        $query = $this->db->query("
        SELECT
            (SELECT name FROM advance_status WHERE id = advance_steps.status_id) AS status,
            (SELECT name FROM system_users WHERE hash = advance_steps.user_admin) AS admin,
            (SELECT name FROM system_users WHERE hash = advance.user_hash) AS user_name,
            advance_steps.date,
            advance_steps.notes
        FROM advance_steps
        LEFT JOIN advance ON advance_steps.advance_id = advance.id
        WHERE advance_steps.advance_id = $id
        ORDER BY advance_steps.id DESC
    ");
        return $query->result_array();
    }

    public function changeStatus($id, $data)
    {

        $this->db->query("UPDATE advance_steps SET is_finish = 1 WHERE advance_id = $id AND is_finish = 0;");
        $this->db->query("UPDATE advance SET status_id = '$data[status_id]' WHERE id = $id");
        // add $id to data
        $data['advance_id'] = $id;
        if ($this->canAgreeAdvanceRequest($data['user_hash'])) {
            $new = $this->db->insert('advance_steps', $data);

            if ($data['status_id'] == 1 || $data['status_id'] == 2 || $data['status_id'] == 3) {
                $userAdminToken = $this->UserModel->getMobileToken($data['user_admin']);

                if ($data['status_id'] == 1) {
                    $notificationTitle = 'تم الموافقة على طلب السلفه';
                    $notificationData = ['type' => 7];
                } elseif ($data['status_id'] == 2) {
                    $notificationTitle = 'تم رفض  طلب السلفه';
                    $notificationData = ['type' => 7];
                } elseif ($data['status_id'] == 3) {
                    $notificationTitle = 'تم تمرير  طلب السلفه';
                    $notificationData = ['type' => 8];
                }

                if ($_SERVER['SERVER_NAME'] !== 'localhost') {
                    if ($userAdminToken && $data['user_hash'] !== $data['user_admin']) {
                        $this->jwtmiddleware->sendNot(
                            $notificationTitle,
                            json_encode($notificationData),
                            $userAdminToken,
                            $notificationTitle
                        );
                    }
                }


            }
            return $new;
        } else {
            return "ليس لديك صلاحيه";
        }

    }

    public function createStep($data)
    {
        $this->db->insert('advance_steps', $data);
        return $this->db->insert_id();
    }

    public function getAdvanceStatus()
    {
        $data = $this->db->get('advance_status')->result_array();
        return $data;
    }

    public function whoCan($type)
    {
        // select name,hash from system_users join emp_information on user_hash=system_users.hash where advance_agreement="1";
        $data = $this->db->select('system_users.name,system_users.hash');
        $data = $this->db->from('system_users');
        $data = $this->db->join('emp_information', 'user_hash=system_users.hash');
        if ($type == "agreement") {
            $data = $this->db->where('advance_agreement', '1');
        } else if ($type == "request") {
            $data = $this->db->where('advance_request', '1');
        }
        $data = $this->db->where('advance_agreement', '1');
        $data = $this->db->get()->result_array();
        return $data;

    }
}
