<?php
class CurrencyModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->load->library('Middleware');
    }

    public function add($data)
    {
        $this->db->insert('currency', $data);
        $currency_id =  $this->db->insert_id();
        return $this->db->insert_id();
    }

    // تحديث عميل
    public function update($hash, $data)
    {
        $this->db->where('hash', $hash);
        $this->db->update('currency', $data);
        return $this->db->affected_rows();
    }

    // حذف عميل
    public function delete($hash)
    {
        $this->db->where('hash', $hash);
        $this->db->delete('currency');
        return $this->db->affected_rows();
    }

    public function get($hash)
    {
        $query = $this->db->get_where('currency', array('hash' => $hash));
        return $query->row_array();
    }

    // استرداد كل المشاريع
    public function get_all()
    {
        $this->db->select('*');
        $this->db->from('currency');

        $this->db->order_by('id', 'DESC');
        $query = $this->db->get();
        return $query->result_array();
    }


    public function count_records()
    {
        $this->db->select('count(*) as count');
        $this->db->from('currency');
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }
}