<?php
class EmpPayrollModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }
    public function insertEmpPayroll($data)
    {

        $emp_id = $data['emp_id'];
        $year_month = $data['year_months'];
        $query = $this->db->query("SELECT COUNT(*) as count FROM emp_payroll WHERE emp_id = '$emp_id' AND year_months = '$year_month'");
        $count = $query->row()->count;
        if ($count > 0) {
            return $this->updateEmpPayroll($data, $emp_id);
        }
        $this->db->insert('emp_payroll', $data);
        return $this->db->insert_id();
    }
    public function updateEmpPayroll($data, $emp_id)
    {

        $year_month = $data['year_months'];
        unset($data['hash']);

        // Check if the record is approved
        $this->db->select('approved');
        $this->db->where('emp_id', $emp_id);
        $this->db->where('year_months', $year_month);
        $query = $this->db->get('emp_payroll');

        if ($query->num_rows() > 0) {
            $result = $query->row();
            if ($result->approved == '1') {
                // If approved is 1, return the message
                return "لا يمكن التعديل تم الصرف";
            }
        }

        // Proceed with the update if not approved
        $this->db->set($data);
        $this->db->where('emp_id', $emp_id);
        $this->db->where('year_months', $year_month);
        $this->db->where('approved', '0');
        $this->db->update('emp_payroll', $data);

        return true;
    }
    public function deleteEmpPayroll($id)
    {
        $this->db->where('id', $id);
        $this->db->delete('emp_payroll');
        return $this->db->affected_rows();
    }
    public function isEmpPayRollExist($user_hash, $year_month)
    {
        $user_hash = $this->db->escape_str($user_hash);
        $year_month = $this->db->escape_str($year_month);

        $query = $this->db->query("
        SELECT approved , COUNT(*) as count FROM emp_payroll WHERE emp_id = '$user_hash' AND year_months = '$year_month'
");

        if (!$query) {
            return [
                'founded' => false,
                'count' => 0,
            ];
        }

        $row = $query->row_array();

        return [
            'founded' => ($row['count'] > 0),
            'count' => $row['count'],
            'approved' => $row['approved']

        ];
    }
    public function updateApproveEmpPayroll($user_hash, $approved)
    {
        $data = array(
            'approved' => $approved
        );

        $this->db->where('emp_id', $user_hash);
        $this->db->update('emp_payroll', $data);
    }
    
    public function getDataByHash($hash) {
        $this->db->select('*')->from('emp_payroll')->where('id', $hash);
        return $this->db->get()->row();
    }

    
}