<?php
class EmployeesModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->load->library('Middleware');

    }

    // get all employees
    public function count_records()
    {
        $headers = apache_request_headers();
        $search = $this->input->get('q') ?? '';
        $isWork = $this->input->get('iswork');
        $department = $this->input->get('department') ?? '';

        if (!$isWork) {
            if ($isWork == 2 || $isWork == '2') {
                $isWork = 2;
            } else {
                $isWork = 1;
            }
        }
        $this->db->select('count(*) as count');
        $this->db->from('system_users');
        // inner join
        $this->db->join('emp_information', 'system_users.hash=emp_information.user_hash');
        // where 
        $this->db->where('is_work', $isWork);
        if (isset($search) && $search != 'null' && $search != '') {
            $this->db->like('system_users.name', $search);
            $this->db->or_like('username', $search);
        }
        if (isset($department) && $department != 'null' && $department != '') {
            $this->db->where('emp_information.partment', $department); // if it not work, use table.field. not return name
        }
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }

    // public function getEmployees()
    // {
    //     // get page and limit and search from header
    //     $headers = apache_request_headers();
    //     $page = $headers['page'] ?? 1;
    //     $perPage = $headers['perPage'] ?? 10;
    //     $isWork = $this->input->get('iswork');
    //     $department = $this->input->get('department') ?? '';
    //     // check iswork is undefined or !== 0
    //     if (!isset($isWork) || ($isWork != 2 && $isWork != '2')) {
    //         $isWork = 1;
    //     }
    //     $search = $this->input->get('q') ?? '';
    //     $offset = ($page - 1) * $perPage;
    //     $this->db->select('system_users.name,username,employment_code,password,image_profile,(select name from system_group_name where system_group_name.hash=system_users.user_type) as jop,emp_id as id,(select name from partments where partments.hash=emp_information.partment) as partment,emp_information.partment as part_hash,jop_type,user_type,system_users.hash');
    //     $this->db->select('(SELECT GROUP_CONCAT(office_hash) as office_array FROM office_to_user WHERE user_hash = system_users.hash) as location_of_work');
    //     $this->db->select("vication_agreement,task_agreement,work_in_check_distance,work_out_check_distance");
    //     $this->db->select("emp_information.is_work");
    //     $this->db->from('system_users');
    //     // inner join
    //     $this->db->join('emp_information', 'system_users.hash=emp_information.user_hash');
    //     $this->db->join('partments', 'emp_information.partment = partments.hash', 'left');
    //     // where
    //     $this->db->where('emp_information.is_work !=', '1');
    //     // search
    //     if (isset($department) && $department != 'null' && $department != '') {
    //         $this->db->where('emp_information.partment', $department); // if it not work, use table.field. not return name
    //     }
    //     if (isset($search) && $search != 'null' && $search != '') {
    //         $this->db->like('system_users.name', $search);
    //         $this->db->or_like('username', $search);
    //     }

    //     // order by
    //     $this->db->order_by('emp_information.partment');

    //     // limit
    //     $this->db->limit($perPage, $offset);
    //     $query = $this->db->get();
    //     return $query->result_array();
    // }

    public function getEmployees()
{
    // get page and limit and search from header
    $headers = apache_request_headers();
    $page = $headers['page'] ?? 1;
    $perPage = $headers['perPage'] ?? 10;
    
    // Using $this->input->get() instead of direct access to headers
    $isWork = $this->input->get('iswork');
    $department = $this->input->get('department') ?? '';

    if (!isset($isWork) || $isWork !== '2') {
        $isWork = '2'; 
    } else {
        $isWork = '1';
    }


    
    
    // Check isWork is undefined or !== '1'
    // if (!isset($isWork) || $isWork !== '2') {
    //     $isWork = '2'; // Change the default value to '2'
    // }


   

    $search = $this->input->get('q') ?? '';
    $offset = ($page - 1) * $perPage;

    $this->db->select('system_users.name,username,employment_code,password,image_profile,(select name from system_group_name where system_group_name.hash=system_users.user_type) as jop,emp_id as id,(select name from partments where partments.hash=emp_information.partment) as partment,emp_information.partment as part_hash,jop_type,user_type,system_users.hash');
    $this->db->select('(SELECT GROUP_CONCAT(office_hash) as office_array FROM office_to_user WHERE user_hash = system_users.hash) as location_of_work');
    $this->db->select("vication_agreement,task_agreement,work_in_check_distance,work_out_check_distance");
    $this->db->select("emp_information.is_work");
    $this->db->from('system_users');
    
    // inner join
    $this->db->join('emp_information', 'system_users.hash=emp_information.user_hash');
    $this->db->join('partments', 'emp_information.partment = partments.hash', 'left');
    
    // where
    $this->db->where('emp_information.is_work !=', $isWork);

    // search
    if (isset($department) && $department != 'null' && $department != '') {
        $this->db->where('emp_information.partment', $department);
    }
    
    if (isset($search) && $search != 'null' && $search != '') {
        $this->db->group_start();
        $this->db->like('system_users.name', $search);
        $this->db->or_like('username', $search);
        $this->db->group_end();
    }

    // order by
    $this->db->order_by('emp_information.partment');

    // limit
    $this->db->limit($perPage, $offset);

    $query = $this->db->get();
    return $query->result_array();
}


    // get employee by hash
    public function getEmployee($hash)
    {
        $this->db->select('
            name,username,password,employment_code,
            user_type,vication_agreement,task_agreement,
            work_in_check_distance,work_out_check_distance,
            primary_salary,vacations_limit,sick_leave,status,
            work_from,work_to,allow_time,birthday,address,phone1,
            phone2,partment,start_work_date,jop_type,is_work,image_profile,
            (select name from system_group_name where system_group_name.hash=system_users.user_type) as jop
        ');
        $this->db->select('
            (SELECT GROUP_CONCAT((select name from office_location where hash=office_hash)) as office_array FROM office_to_user WHERE user_hash = system_users.hash) as name_location_of_work,
            (SELECT GROUP_CONCAT(office_hash) as office_array FROM office_to_user WHERE user_hash = system_users.hash) as location_of_work
        ');
        $this->db->from('system_users');
        // inner join
        $this->db->join('emp_information', 'system_users.hash=emp_information.user_hash');
        // where 
        $this->db->where('system_users.hash', $hash);

        $query = $this->db->get();
        return $query->result_array();
    }

    public function getEmployeeForAccount($hash)
    {
        $this->db->select('id,name');
        $this->db->from('system_users');
        $this->db->where('system_users.hash', $hash);
        $query = $this->db->get();
        return $query->result_array();
    }

    public function getEmployeeVacations($hash)
    {
        $this->db->select("
            date(date_start) as start,
            date(date_end) as end,
            hash,
            note,
            (select type from vacations_type where hash=vacations.vication_type_hash) as type,
            (select title from vacations_status where hash=vacations.status) as status,
            (select name from system_users where hash=admin) as admin_name
        ");
        $this->db->from('vacations');
        $this->db->where('user_hash', $hash);
        // order by
        $this->db->order_by('vacations.id', 'DESC');
        $query = $this->db->get();
        return $query->result_array();
    }

    public function getEmployeeFingerPrint($hash)
    {
        $this->db->select('*');
        $this->db->from('finger_print_report');
        $this->db->where('emp_hash', $hash);

        $query = $this->db->get();
        return $query->result_array();
    }

    public function createEmployee($data)
    {
        $this->db->query("INSERT INTO 
            system_users (name,username,password,user_type,hash, employment_code) 
            VALUES ('{$data['name']}','{$data['username']}','{$data['password']}','{$data['user_type']}','{$data['hash']}','{$data['employment_code']}')");
    
        $this->db->query("
    INSERT INTO emp_information (user_hash) 
    VALUES ('{$data['hash']}')
");

        return $this->db->affected_rows();
    }





    public function updatePermission($data)
    {
        $this->db->query("
        UPDATE emp_information SET  
            work_in_check_distance = '{$data['work_in_check_distance']}',
            work_out_check_distance = '{$data['work_out_check_distance']}'
        WHERE user_hash = '{$data['hash']}'
        ");
        $this->db->query("
        UPDATE system_users SET  
            vication_agreement = '{$data['vication_agreement']}',
            task_agreement = '{$data['task_agreement']}'
        WHERE hash = '{$data['hash']}'
        ");
        return $this->db->affected_rows();
    }

    public function updateEmpInfo($data)
    {
    
        $this->db->query("
        UPDATE emp_information SET  
            primary_salary = '{$data['primary_salary']}',
            vacations_limit = '{$data['vacations_limit']}',
            sick_leave = '{$data['sick_leave']}',
            status = '{$data['status']}',
            work_from = '{$data['work_from']}',
            work_to = '{$data['work_to']}',
            allow_time = '{$data['allow_time']}',
            work_in_check_distance = '{$data['work_in_check_distance']}',
            work_out_check_distance = '{$data['work_out_check_distance']}',
            birthday = '{$data['birthday']}',
            address = '{$data['address']}', status = '{$data['status']}',
            phone1 = '{$data['phone1']}',
            phone2 = '{$data['phone2']}',
            partment = '{$data['partment']}',
            start_work_date = '{$data['start_work_date']}',
            jop_type = '{$data['jop_type']}',
            is_work = '{$data['is_work']}'
        WHERE user_hash = '{$data['hash']}'
        ");
        return $this->db->affected_rows();
    }

    public function createLocations($data)
    {
        // delete all locations
        $this->db->where('user_hash', $data['hash']);
        $this->db->delete('office_to_user');
        // insert new locations from location_of_work like 16678156717559213,16648815219977578
        $locations = explode(',', $data['location_of_work']);
        foreach ($locations as $location) {
            $this->db->query("INSERT INTO office_to_user (user_hash,office_hash) VALUES ('{$data['hash']}','{$location}')");
        }
        return $this->db->affected_rows();
    }

    public function updateEmp($data)
    {
        $this->db->query("
        UPDATE system_users SET 
            name = '{$data['name']}',
            username = '{$data['username']}',
            password = '{$data['password']}',
            user_type = '{$data['user_type']}',
            vication_agreement = '{$data['vication_agreement']}',
            task_agreement = '{$data['task_agreement']}',
            image_profile = '{$data['image_profile']}',
            employment_code = '{$data['employment_code']}'
        WHERE hash = '{$data['hash']}'
        ");
        return $this->db->affected_rows();
    }

    public function deleteEmployee($hash)
    {
        $this->db->where('user_hash', $hash);
        $this->db->update('emp_information', ['is_work' => '2']);
        return $this->db->affected_rows();
    }

    public function employeesCanAcceptVacations($hash, $user_type)
    {
        // SELECT * FROM system_users inner join emp_information on  system_users.hash=emp_information.user_hash where is_work='1' and vication_agreement='1' and system_users.hash<>'${CacheService.hash}
        $this->db->select('
            name,hash
        ')->from('system_users');
        $this->db->join('emp_information', 'system_users.hash=emp_information.user_hash');
        $this->db->where("is_work = 1 and  system_users.hash != '$hash' ");
        // and (user_type = $user_type or partment = '1337866435131594') vication_agreement = 1 and
        $query = $this->db->get();
        return $query->result_array();
    }

    public function getCurrentVacationsOfUser($hash)
    {
        //
        $query = $this->db->query("
            SELECT 
                vacations.hash AS 'vication_number',
                vacations.user_hash AS 'user_hash',
                vacations.datetime AS 'create_date',
                (SELECT 
                        name
                    FROM
                        system_users
                    WHERE
                        system_users.hash = vacations.user_hash
                    LIMIT 1) AS 'user_name',
                (SELECT 
                        type
                    FROM
                        vacations_type
                    WHERE
                        vacations_type.hash = vacations.vication_type_hash) AS 'type',
                (SELECT 
                        title
                    FROM
                        vacations_status
                    WHERE
                        vacations_status.hash = vacations_agreement.status) AS 'agreement_status',
                (SELECT 
                        title
                    FROM
                        vacations_status
                    WHERE
                        vacations_status.hash = vacations.status) AS 'final_status',
                DATEDIFF(date_end, date_start) AS 'diff_day',
                TIMESTAMPDIFF(HOUR,
                    date_start,
                    date_end) AS 'diff_hours',
                date_start AS 'start',
                date_end AS 'end',
                vacations_agreement.hash AS 'agreement_hash',
                vacations_agreement.note AS 'final_note'
            FROM
                vacations
                    INNER JOIN
                    vacations_agreement ON vacations.hash = vacations_agreement.vacations_hash and vacations_agreement.id = (select max(id) from vacations_agreement where vacations_hash=vacations.hash)
            WHERE
                vacations_agreement.id IN (SELECT 
                        MAX(id) AS last_agrement
                    FROM
                        vacations_agreement
                    GROUP BY vacations_agreement.vacations_hash) and user_hash = '{$hash}'
            ORDER BY create_date DESC
        ");
        return $query->result_array();
    }

    public function getHistoryOfVacation($hash)
    {
        $query = $this->db->query("
            SELECT 
                vacations.hash AS 'vication_number',
                vacations.user_hash AS 'user_hash',
                vacations.datetime AS 'create_date',
                (SELECT 
                        name
                    FROM
                        system_users
                    WHERE
                        system_users.hash = vacations.user_hash
                    LIMIT 1) AS 'user_name',
                (SELECT 
                        type
                    FROM
                        vacations_type
                    WHERE
                        vacations_type.hash = vacations.vication_type_hash) AS 'type',
                (SELECT 
                        title
                    FROM
                        vacations_status
                    WHERE
                        vacations_status.hash = vacations_agreement.status) AS 'agreement_status',
                (SELECT 
                        title
                    FROM
                        vacations_status
                    WHERE
                        vacations_status.hash = vacations.status) AS 'final_status',
                DATEDIFF(date_end, date_start) AS 'diff_day',
                TIMESTAMPDIFF(HOUR,
                    date_start,
                    date_end) AS 'diff_hours',
                date_start AS 'start',
                date_end AS 'end'
            FROM
                vacations
                    INNER JOIN
                    vacations_agreement ON vacations.hash = vacations_agreement.vacations_hash and vacations_agreement.id = (select max(id) from vacations_agreement where vacations_hash=vacations.hash)
            WHERE
                vacations_agreement.sender = '{$hash}'
                    AND (vacations_agreement.status = '111'
                    OR vacations_agreement.status = '222'
                    OR vacations_agreement.status = '333')
            ORDER BY vacations.id DESC
        ");
        return $query->result_array();
    }

    public function receivedVAcationsOfUser($hash)
    {
        $query = $this->db->query("
            SELECT 
                vacations.hash AS 'vication_number',
                vacations.user_hash AS 'user_hash',
                vacations.datetime AS 'create_date',
                (SELECT 
                        name
                    FROM
                        system_users
                    WHERE
                        system_users.hash = vacations.user_hash
                    LIMIT 1) AS 'user_name',
                (SELECT 
                        type
                    FROM
                        vacations_type
                    WHERE
                        vacations_type.hash = vacations.vication_type_hash) AS 'type',
                (SELECT 
                        title
                    FROM
                        vacations_status
                    WHERE
                        vacations_status.hash = vacations_agreement.status) AS 'agreement_status',
                (SELECT 
                        title
                    FROM
                        vacations_status
                    WHERE
                        vacations_status.hash = vacations.status) AS 'final_status',
                DATEDIFF(date_end, date_start) AS 'diff_day',
                TIMESTAMPDIFF(HOUR,
                    date_start,
                    date_end) AS 'diff_hours',
                date_start AS 'start',
                date_end AS 'end',
                vacations_agreement.hash AS 'agreement_hash',
                vacations.note AS 'main_note',
                vacations_agreement.note AS 'comment_note'
            FROM
                vacations
                    INNER JOIN
                    vacations_agreement ON vacations.hash = vacations_agreement.vacations_hash and vacations_agreement.id = (select max(id) from vacations_agreement where vacations_hash=vacations.hash)
            WHERE
                vacations_agreement.receiver = '{$hash}'
                    AND vacations_agreement.sender <> '{$hash}'
                    AND (vacations.status = '444' OR vacations.status = '333')
                    AND flage = '0'
            ORDER BY vacations.id DESC
        ");
        return $query->result_array();
    }

    public function getEmployeeDetails($hash)
    {
        $this->db->select('system_users.*, emp_information.*');
        $this->db->select("TIME_FORMAT(work_from, '%r') AS from_work_time");
        $this->db->select("TIME_FORMAT(work_to, '%r') AS to_work_time");
        $this->db->select('GROUP_CONCAT(office_location.name) AS location');
        $this->db->select('(SELECT name FROM partments WHERE partments.hash = emp_information.partment) AS department');
        $this->db->select('(SELECT name FROM office_location WHERE office_location.hash = emp_information.location_of_work LIMIT 1) AS place');
        $this->db->select('(SELECT name FROM system_group_name WHERE system_group_name.hash = system_users.user_type) AS emp_title');
        $this->db->from('system_users');
        $this->db->join('emp_information', 'system_users.hash = emp_information.user_hash', 'left');
        $this->db->join('office_to_user', 'office_to_user.user_hash = system_users.hash', 'left');
        $this->db->join('office_location', 'office_to_user.office_hash = office_location.hash', 'left');
        $this->db->join('system_put_role_to_users', 'system_users.hash = system_put_role_to_users.user_hash', 'left');
        $this->db->where('system_users.hash', "$hash");
        $query = $this->db->get();
        return $query->result_array();
    }
}