<?php
class GroupsModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    // get all Groups
    public function count_records()
    {
        $headers = apache_request_headers();
        $search = $headers['q'] ?? '';
        $this->db->select('count(*) as count');
        $this->db->from('system_group_name');
        if ($search) {
            $this->db->like('name', $search);
        }
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }

    public function getGroups()
    {
        // get page and limit and search from header
        $headers = apache_request_headers();
        $page = $headers['page'] ?? 1;
        $perPage = $headers['perPage'] ?? 10;
        $search = $headers['q'] ?? '';
        $offset = ($page - 1) * $perPage;
        $this->db->select('name,hash');
        $this->db->from('system_group_name');
        // search
        if ($search) {
            $this->db->like('name', $search);
        }
        // order by
        $this->db->order_by('id', 'DESC');
        // limit
        $this->db->limit($perPage, $offset);
        $query = $this->db->get();
        return $query->result_array();
    }
}
