<?php
class HolidayModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    // get all Groups
    public function count_records()
    {
        $headers = apache_request_headers();
        $this->db->select('count(*) as count');
        $this->db->from('holiday');
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }

    public function getHolidays()
    {

        $this->db->select('type as title, date, hash as id');
        $this->db->from('holiday');
        $query = $this->db->get();
        return $query->result_array();
    }

    function getHoliday($hash)
    {
        $this->db->select('type, date, hash');
        $this->db->from('holiday');
        $this->db->where('hash =', $hash);
        $query = $this->db->get();

        return $query->result_array();
    }

    function addHoliday($data)
    {
        $this->db->insert('holiday', $data);
        return $this->db->insert_id();
    }

    function updateHoliday($hash, $data)
    {
        $this->db->where('hash', $hash);
        $this->db->update('holiday', $data);
        return $this->db->affected_rows();
    }

    function deleteHoliday($hash)
    {
        $this->db->where('hash', $hash);
        $this->db->delete('holiday');
        return $this->db->affected_rows();
    }
}