<?php

class JobTitlesModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    public function count_records()
    {
        $page = $this->input->get("page") ?? 1;
        $perPage = $this->input->get("perPage") ?? 10;
        $offset = ($page - 1) * $perPage;

        $search = $this->input->get("q") ?? '';

        $this->db->select("count(*) as count")->from('job_title');

        if (!empty($search)) {
            $this->db->like('name', $search);
        }

        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }

    public function get_records()
    {
        $page = $this->input->get("page") ?? 1;
        $perPage = $this->input->get("perPage") ?? 10;
        $offset = ($page - 1) * $perPage;

        $search = $this->input->get("q") ?? '';

        $this->db->select("*")->from('job_title');
        $this->db->limit($perPage, $offset);

        if (!empty($search)) {
            $this->db->like('name', $search);
        }
        return $this->db->get()->result_array();
    }

    // this for select
    public function get_select_all_records()
    {
        $this->db->select("id as value , name as label")->from('job_title');
        return $this->db->get()->result_array();
    }

    public function get_records_by_id($id)
    {
        $this->db->select("*")->from('job_title')->where('id', $id);
        return $this->db->get()->row();
    }

    public function insert_record($data)
    {
        $this->db->select('id')->from('job_title')->where('name', $data['name']);
        $result = $this->db->get()->row();

        if (empty($result)) {
            $this->db->insert('job_title', $data);
            return $this->db->insert_id();
        } else {
            return "هذاالمسمى مستخدم من قبل"; // or throw an exception or return a custom error message
        }
    }

    public function update_record($id, $data)
    {
        $this->db->where('id', $id);
        $this->db->update('job_title', $data);
        return $this->db->affected_rows();
    }

    public function delete_record($id)
    {
        $this->db->select('id')->from('job_title')->where('id', $id);
        $result = $this->db->get()->row();

        if (!empty($result)) {
            $this->db->where('id', $id);
            $this->db->delete('job_title');
            return $this->db->affected_rows();
        } else {
            return "هذا المسمى غير موجود"; // or throw an exception or return a custom error message
        }
    }

}
