<?php
class Migration_model extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    private $batch_size = 1000; // Adjust based on your needs

    public function migrate_subscriber_data()
    {
        // Get total count for progress tracking
        $total = $this->db->query("
            SELECT COUNT(*) as count 
            FROM view_subscriber_info 
            JOIN ftth_primaty_informations 
            ON ftth_primaty_informations.customer_id = view_subscriber_info.customer_id
        ")->row()->count;

        $offset = 0;
        $processed = 0;

        while ($processed < $total) {
            // Get batch of records
            $query = $this->db->query("
                SELECT 
                    view_subscriber_info.mobile,
                    ftth_primaty_informations.customer_id,
                    ftth_primaty_informations.username AS user_name,
                    ftth_primaty_informations.zone,
                    ftth_primaty_informations.fat,
                    ftth_primaty_informations.customer_displayValue,
                    ftth_primaty_informations.ipAddress,
                    ftth_primaty_informations.expires,
                    ftth_primaty_informations.hasActiveSession,
                    ftth_primaty_informations.board,
                    ftth_primaty_informations.updated_at
                FROM view_subscriber_info
                JOIN ftth_primaty_informations 
                ON ftth_primaty_informations.customer_id = view_subscriber_info.customer_id
                LIMIT ? OFFSET ?
            ", array($this->batch_size, $offset));

            $batch_data = $query->result_array();

            if (!empty($batch_data)) {
                // Insert batch
                $this->db->insert_batch('subscriber_ftth_data_combined', $batch_data);

                // Update progress
                $processed += count($batch_data);
                $offset += $this->batch_size;

            }

            // Clear result from memory
            $query->free_result();
        }

        return array(
            'status' => 'success',
            'total_processed' => $processed,
            'total_records' => $total
        );
    }
}
