<?php
class NotificationModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    // get all Offices
    public function count()
    {
        $query = $this->db->query("
            SELECT title,count FROM (
                (SELECT COUNT(*) AS count, 'taskToday' as title FROM task WHERE date(deadline) = CURDATE() ) union
                (SELECT COUNT(*) AS count, 'tasks' as title FROM task WHERE status = 444 or status = 111 ) union
                (select COUNT(*) as count , 'vacationToday' as title from vacations WHERE date(date_start) >= CURDATE() AND date(date_end) >= CURDATE()) union
                (select COUNT(*) as count , 'vacations' as title from vacations WHERE status = 444 or status = 333) union
                (select COUNT(*) as count , 'checkIns' as title from notification where type ='check_in' and isreaded=0 ) union
                (select COUNT(*) as count , 'checkToday' as title from check_in where date(data_entry) = CURDATE() )
            ) AS count;
        ");
        return $query->result_array();
    }

    public function getNotifications()
    {
        // get * from notification table
        $query = $this->db->query("
            SELECT notification.id,title,text,type,name,image_profile as image,notification.user_hash,
            TIME_FORMAT(notification.data_entry, '%h:%i %p') AS time
            FROM notification
            inner join system_users on notification.user_hash = system_users.hash
            where notification.isreaded = '0'
            order by notification.id desc
            LIMIT 200
            ;
        ");
        return $query->result_array();
    }

    public function createNotification($title, $type, $text, $user_hash)
    {
        $query = $this->db->query("
            INSERT INTO notification (title,type,text,user_hash) VALUES ('$title','$type','$text','$user_hash');
        ");
        return $query;
    }

    public function deleteNotification($id)
    {
        $query = $this->db->query("
            UPDATE notification SET isreaded = '1' WHERE id = '$id';
        ");
        return $query;
    }

    public function deleteAllNotification()
    {
        $query = $this->db->query("
            UPDATE notification SET isreaded = '1';
        ");
        return $query;
    }

}
