<?php
class OfficesModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    // get all Offices
    public function count_records()
    {
        $headers = apache_request_headers();
        $search = $headers['q'] ?? '';
        $this->db->select('count(*) as count');
        $this->db->from('office_location');
        if ($search) {
            $search = urldecode($search);

            $this->db->like('name', $search);
        }
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }

    public function getOffices()
    {
        // get page and limit and search from query string
        $page = $this->input->get('page') ?? 1;
        $perPage = $this->input->get('perPage') ?? 10;
        $search = $this->input->get('q') ?? '';
        // decode search
        $search = urldecode($search);
        $offset = ($page - 1) * $perPage;
        $this->db->select('
    name,hash,address,allow_merters,
    ST_X(location) as x,
    ST_Y(location) as y
    ');
        $this->db->from('office_location');
        // search
        if ($search) {
            $this->db->like('name', $search);
        }
        // order by
        $this->db->order_by('id', 'DESC');
        // limit
        $this->db->limit($perPage, $offset);
        $query = $this->db->get();
        return $query->result_array();
    }
    
    public function getOffice($hash)
    {
        $this->db->select('
        name,hash,address,allow_merters,
        ST_X(location) as x,
        ST_Y(location) as y
        ');
        $this->db->from('office_location');
        $this->db->where('hash', $hash);
        $query = $this->db->get();
        return $query->result_array()[0];
    }

    public function insertOffice($data)
    {
        $this->db->query("
        INSERT INTO office_location (name,hash,address,allow_merters,location)
        VALUES (
            '" . $data['name'] . "',
            '" . $data['hash'] . "',
            '" . $data['address'] . "',
            '" . $data['allow_merters'] . "',
            ST_GeomFromText('POINT(" . $data['x'] . " " . $data['y'] . ")')
        )
        ");
        return $this->db->affected_rows();
    }

    public function updateOffice($data, $hash)
    {
        $this->db->query("
        UPDATE office_location SET
        name = '" . $data['name'] . "',
        hash = '" . $data['hash'] . "',
        address = '" . $data['address'] . "',
        allow_merters = '" . $data['allow_merters'] . "',
        location = ST_GeomFromText('POINT(" . $data['x'] . " " . $data['y'] . ")')
        WHERE hash = '" . $hash . "'
        ");
        return $this->db->affected_rows();
    }

    public function deleteOffice($hash)
    {
        $this->db->where('hash', $hash);
        $this->db->delete('office_location');
        return $this->db->affected_rows();
    }
}
