<?php
class OrderTypeModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    // get all Groups
    public function count_records()
    {
        $headers = apache_request_headers();
        $search = $headers['q'] ?? '';
        $this->db->select('count(*) as count');
        $this->db->from('administrative_order_type');
        if ($search) {
            $this->db->like('title', $search);
        }
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }

    public function getOrderTypes()
    {
        // get page and limit and search from header
        $headers = apache_request_headers();
        $page = $headers['page'] ?? 1;
        $perPage = $headers['perPage'] ?? 10;
        $search = $this->input->get('q') ?? '';
        $offset = ($page - 1) * $perPage;

        $this->db->select(
            'title as label,hash as value'
        );
        $this->db->from('administrative_order_type');
        // search
        if ($search) {
            $this->db->like('title', $search);
        }
        // orderType by
        $this->db->order_by('id', 'DESC');
        // limit
        $this->db->limit($perPage, $offset);
        $query = $this->db->get();
        return $query->result_array();
    }

    function getOrderType($hash)
    {
        $this->db->select(
            'title as label,hash as value'
        );
        $this->db->from('administrative_order_type');
        $this->db->where('hash =', $hash);
        $query = $this->db->get();

        return $query->result_array();
    }

    function addOrderType($data)
    {
        $this->db->insert('administrative_order_type', $data);
        return $this->db->insert_id();
    }

    function updateOrderType($hash, $data)
    {
        $this->db->where('hash', $hash);
        $this->db->update('administrative_order_type', $data);
        return $this->db->affected_rows();
    }

    function deleteOrderType($hash)
    {
        $this->db->where('hash', $hash);
        $this->db->delete('administrative_order_type');
        return $this->db->affected_rows();
    }
}
