<?php
class PartmentsModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    // get all Partments
    public function count_records()
    {
        $headers = apache_request_headers();
        $search = $headers['q'] ?? '';
        $this->db->select('count(*) as count');
        $this->db->from('partments');
        if ($search) {
            // decode search value
            $search = urldecode($search);
            $this->db->like('name', $search);
        }
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }

    public function getPartments()
    {
        // get page and limit and search from header
        $headers = apache_request_headers();
        $page = $headers['page'] ?? 1;
        $perPage = $headers['perPage'] ?? 10;
        $search = $headers['q'] ?? '';
        $offset = ($page - 1) * $perPage;
        $this->db->select('name,hash');
        $this->db->from('partments');
        // search
        if ($search) {
            $search = urldecode($search);
            $this->db->like('name', $search);
        }
        // order by
        $this->db->order_by('id', 'DESC');
        // limit
        $this->db->limit($perPage, $offset);
        $query = $this->db->get();
        return $query->result_array();
    }

    public function getPart($hash)
    {
        $this->db->select('
        name,hash
        ');
        $this->db->from('partments');
        $this->db->where('hash', $hash);
        $query = $this->db->get();
        return $query->result_array()[0];
    }

    public function insertPart($data)
    {
        $this->db->insert('partments', $data);
        return $this->db->insert_id();
    }

    public function updatePart($data, $hash)
    {
        $this->db->where('hash', $hash);
        $this->db->update('partments', $data);
        return $this->db->affected_rows();
    }

    public function deletePart($hash)
    {
        $this->db->where('hash', $hash);
        $this->db->delete('partments');
        return $this->db->affected_rows();
    }

    public function getUsersByPart($hash)
    {
        $this->db->select('
        user_hash as value,
        (select name from system_users where hash = user_hash) as label
        ');
        $this->db->from('emp_information');
        $this->db->where('partment', $hash);
        $query = $this->db->get();
        return $query->result_array();
    }
}
