<?php

class PositionOtherModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    public function count_records()
    {
        $search = $this->input->get('q') ?? '';
        $this->db->select('count(*) as count');
        $this->db->from('positions_other');
        if ($search) {
            $this->db->like('name', $search);
        }
        $query = $this->db->get();
        return $query->result_array()[0]['count'];
    }

    public function get()
    {
        $page = $this->input->get('page') ?? '1';

        $perPage = $this->input->get('perPage') ?? '10';

        $search = $this->input->get('q') ?? '';

        $offset = ($page - 1) * $perPage;


        $this->db->select('*');
        $this->db->from('positions_other');

        if ($search) {
            $this->db->like('name', $search);
        }
        $this->db->order_by('id', 'ASC');
        $this->db->limit($perPage, $offset);

        $query = $this->db->get();
        return $query->result_array();
    }
    public function getById($positionSpecificationsId)
    {

        $this->db->where('id', $positionSpecificationsId);
        $query = $this->db->get('positions_other');

        if ($query->num_rows() > 0) {
            $result = $query->row_array();
            return $result;
        } else {
            return null;
        }
    }

    public function insert($data)
    {
        if (empty($data)) {
            return;
        }

        $this->db->select('name');
        $this->db->from('positions_other');
        $this->db->where('name', $data['name']);
        $countName = $this->db->get()->num_rows();

        if ($countName > 0) {
            return "هذ المخصص موجود بل الفعل";
        }

        $validData = array_intersect_key($data, array_flip(['name']));
        $this->db->insert('positions_other', $validData);
        return $this->db->insert_id();
    }

    public function update($data)
    {
        $validData = array_intersect_key($data, array_flip(['name']));
        $id = $data['id'];


        $this->db->where('id', $id);
        $this->db->update('positions_other', $validData);
        return true;
    }

    public function delete($id)
    {
        $table_name = 'positions_other';

        $existing_record = $this->db->get_where($table_name, ['id' => $id])->row();
        if (!$existing_record) {
            return false;
        }

        $this->db->where('id', $id);
        $this->db->delete($table_name);

        return true;
    }
}