<?php
class ReportModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
        $this->load->model('EmployeesWorkedHoursModel');
    }

    // get all Groups
    public function get_stay_records()
    {
        $start_date = $this->input->post('start_date');
        $end_date = $this->input->post('end_date');
        $search = $this->input->post('q');
        $department = $this->input->post("department");
        if ($search) {
            $search = "and emp_fingerprint.user_hash = '$search'";
        }
        if (isset($department) && $department != "null" && $department != "") {
            $department = "and emp_information.partment = '$department'";
        }
        $query = $this->db->query("
            SELECT count(*) as count
            FROM emp_fingerprint
            inner join emp_information on emp_fingerprint.user_hash=emp_information.user_hash
            WHERE in_out = 'in'
            AND fingerprint_type = '111'
            AND time(fingerprint_time) > allow_time
            AND date(fingerprint_time) >= '$start_date'
            AND date(fingerprint_time) <= '$end_date'
            $search $department
        ");
        $result = $query->row_array();
        return $result['count'];
    }

    public function getStayReport()
    {
        $start_date = $this->input->post('start_date');
        $end_date = $this->input->post('end_date');
        // get page and limit and search from header
        $search = $this->input->post('q');
        $page = intval($this->input->post("page")) ?? 1;
        $perPage = intval($this->input->post("perPage")) ?? 15;
        $department = $this->input->post("department");
        $offset = ($page - 1) * $perPage;
        if ($search) {
            $search = "And emp_fingerprint.user_hash = '$search'";
        }
        if (isset($department) && $department != "null" && $department != "") {
            $department = "and emp_information.partment = '$department'";
        }
        $query = $this->db->query(
            "
            SELECT emp_information.user_hash,
            (select name from system_users where hash=emp_fingerprint.user_hash limit 1) as name,
            (select name from partments where hash=emp_information.partment) as department,
            (select image_profile from system_users where hash=emp_fingerprint.user_hash limit 1) as image,
            (select name from system_group_name where hash=(select user_type from system_users where hash=emp_fingerprint.user_hash)) as job,
            date(fingerprint_time) as 'date',
            time_format(time(fingerprint_time),'%r') as 'time',
            time_format(time(allow_time),'%r') as allow_time
            FROM emp_fingerprint
            inner join emp_information on emp_fingerprint.user_hash=emp_information.user_hash
            WHERE in_out = 'in'
            AND fingerprint_type = '111'
            AND time(fingerprint_time) > allow_time
            AND date(fingerprint_time) >= '$start_date'
            AND date(fingerprint_time) <= '$end_date'
            $search $department
            ORDER BY fingerprint_time DESC
            LIMIT $offset, $perPage"
        );
        return $query->result_array();
    }

    public function get_late_records()
    {
        $start_date = $this->input->post('start_date');
        $end_date = $this->input->post('end_date');
        $search = $this->input->post('q');
        if ($search) {
            $search = "and emp_fingerprint.user_hash = '$search'";
        }
        $query = $this->db->query("
            SELECT count(*) as count
            FROM emp_fingerprint
            inner join emp_information on emp_fingerprint.user_hash=emp_information.user_hash
            WHERE in_out = 'out'
            AND fingerprint_type = '111'
            AND time(fingerprint_time) > work_to
            AND date(fingerprint_time) >= '$start_date'
            AND date(fingerprint_time) <= '$end_date'
            $search
        ");
        $result = $query->row_array();
        return $result['count'];
    }

    public function getLateReport()
    {
        $start_date = $this->input->post('start_date');
        $end_date = $this->input->post('end_date');
        // get page and limit and search from header
        $search = $this->input->post('q');
        $page = intval($this->input->post("page")) ?? 1;
        $perPage = intval($this->input->post("perPage")) ?? 15;
        $offset = ($page - 1) * $perPage;
        if ($search) {
            $search = "And emp_fingerprint.user_hash = '$search'";
        }
        $query = $this->db->query("
            SELECT emp_information.user_hash,
            (select name from system_users where hash=emp_fingerprint.user_hash limit 1) as name,
            (select image_profile from system_users where hash=emp_fingerprint.user_hash limit 1) as image,
            (select name from system_group_name where hash=(select user_type from system_users where hash=emp_fingerprint.user_hash)) as job,
            date(fingerprint_time) as 'date',
            time_format(time(fingerprint_time),'%r') as 'time',
            time_format(time(work_to),'%r') as allow_time
            FROM emp_fingerprint
            inner join emp_information on emp_fingerprint.user_hash=emp_information.user_hash
            WHERE in_out = 'out'
            AND fingerprint_type = '111'
            AND time(fingerprint_time) > work_to
            AND date(fingerprint_time) >= '$start_date'
            AND date(fingerprint_time) <= '$end_date'
            $search
            ORDER BY fingerprint_time DESC
            LIMIT $offset, $perPage
        ");
        return $query->result_array();
    }

    public function get_not_phone_records()
    {
        $start_date = $this->input->post('start_date');
        $end_date = $this->input->post('end_date');
        $search = $this->input->post('q');
        $department = $this->input->post("department");

        $this->db->select('COUNT(*) as count');
        $this->db->from('device_log');
        $this->db->join('system_users', 'device_log.user_hash = system_users.hash');
        $this->db->join('emp_information', 'system_users.hash = emp_information.user_hash');
        $this->db->join('Positions', 'Positions.id = emp_information.position');
        $this->db->where('device_log.status', '1');
        $this->db->where("DATE(record_date) >= '$start_date'");
        $this->db->where("DATE(record_date) <= '$end_date'");
        if (isset($department) && $department != "null") {
            $this->db->like("Positions.Name", $department);

        }
        $this->db->like('system_users.name', $search);
        $this->db->order_by("system_users.name");

        $query = $this->db->get();
        $result = $query->row_array();
        return $result['count'] ?? 0;
    }


    public function getNotPhoneReport()
    {
        $start_date = $this->input->post('start_date');
        $end_date = $this->input->post('end_date');
        // get page and limit and search from header
        $search = $this->input->post('q');
        $page = intval($this->input->post("page")) ?? 1;
        $perPage = intval($this->input->post("perPage")) ?? 15;
        $department = $this->input->post("department");
        $offset = ($page - 1) * $perPage;
        $this->db->select('system_users.name as user,
                           date(device_log.record_date) as date,
                           device_log.old_mobile_info as mobile_info,
                           device_log.new_mobile_info as mobile, device_log.hash,
                           system_users.image_profile as image,
                           Positions.Name as job,
                           system_users.hash as user_hash');
        $this->db->from('device_log');
        $this->db->join('system_users', 'device_log.user_hash = system_users.hash');
        $this->db->join('emp_information', 'system_users.hash = emp_information.user_hash');
        $this->db->join('Positions', 'Positions.id = emp_information.position');
        $this->db->where('device_log.status', '1');
        $this->db->where("DATE(record_date) >= '$start_date'");
        $this->db->where("DATE(record_date) <= '$end_date'");
        if (isset($department) && $department != "null") {
            $this->db->like("Positions.Name", $department);

        }
        $this->db->like('system_users.name', $search);
        $this->db->order_by("system_users.name");
        $this->db->limit($perPage, $offset);
        $query = $this->db->get();
        return $query->result_array();
    }

    // حساب المرتبات
    public function get_salary_records()
    {
        $penaltyMutiply = $this->EmployeesWorkedHoursModel->getMainPenalty();
        $department_id = $this->input->post('department') ?? '';
        // search
        $search = $this->input->post('q') ?? '';
        $user_hash = $this->input->post('user_hash') ?? '';
        $page = intval($this->input->post("page")) ?? 1;
        $perPage = intval($this->input->post("perPage")) ?? 10;
        // start and end date
        $start_date = $this->input->post('start_date');
        $end_date = $this->input->post('end_date');
        $count = $this->db->query("
            select
                count(*) as count
            from
                system_users
            left join
                emp_information on system_users.hash = emp_information.user_hash
        ");
        $count = $count->row_array();
        $count = $count['count'];
        // $query = $this->db->query("call fp_report('$start_date', '$end_date','$department_id','$search','$page','$perPage')");
        $sql = "
SELECT
    COALESCE(b.user_hash, l.user_hash) AS user_hash,
    TIME_FORMAT(SEC_TO_TIME(COALESCE(b.total_worked_hours, 0) * 3600), '%H:%i:%s') AS work_hour,
    TIME_FORMAT(SEC_TO_TIME(COALESCE(b.total_target_hours, 0) * 3600), '%H:%i:%s') AS work_hour_target,
    TIME_FORMAT(SEC_TO_TIME(COALESCE(b.total_overtime_hours, 0) * 3600), '%H:%i:%s') AS over_time,
    TIME_FORMAT(SEC_TO_TIME(COALESCE(b.total_missing_hours, 0) * 3600), '%H:%i:%s') AS cut_off_hours,
    TIME_FORMAT(SEC_TO_TIME(COALESCE(b.total_late_arrival_minutes, 0) * 60), '%H:%i:%s') AS finger_limit_in,
    TIME_FORMAT(SEC_TO_TIME(COALESCE(b.total_early_departure_minutes, 0) * 60), '%H:%i:%s') AS finger_limit_out,
    COALESCE(l.total_sick_leave_days, 0) AS sick_vacation_hour,
    COALESCE(l.total_regular_leave_days, 0) AS total_regular_leave_days,
    COALESCE(l.total_time_leave_days, 0) AS total_time_leave_days,
    COALESCE(l.total_duty_days, 0) AS duty_hour,
    COALESCE(l.total_unpaid_leave_days, 0) AS total_unpaid_leave_days,
    COALESCE(l.total_weekly_off_days, 0) AS total_weekly_off_days,
    COALESCE(l.total_vacation_days, 0) AS vacation_hour,
    COALESCE(su.name, '') AS name,
    total_absence_days,
    total_attendace_days,
    TIME_FORMAT(SEC_TO_TIME(
        COALESCE(b.total_daily_penalties, 0)
    ), '%H:%i:%s') AS total_penalty_hours
FROM (
    SELECT
        ewh.user_hash,
        ewh.is_flexible,
        SUM(ewh.total_worked_hours) AS total_worked_hours,
        SUM(ewh.target_hours) AS total_target_hours,
        SUM(ewh.overtime_hours) AS total_overtime_hours,
        SUM(CASE WHEN ewh.is_flexible = 0 THEN 0 ELSE 0 END) AS total_missing_hours,
        SUM(ewh.total_late_arrival_minutes) AS total_late_arrival_minutes,
        SUM(ewh.total_early_departure_minutes) AS total_early_departure_minutes,
       SUM(
            CASE
                WHEN ewh.total_worked_hours = 0 AND total_late_arrival_minutes = 0 AND total_early_departure_minutes = 0 THEN ewh.total_missed_hours * 3600 * $penaltyMutiply
                ELSE (ewh.total_late_arrival_minutes * 60 * 3) + (ewh.total_early_departure_minutes * 60 * $penaltyMutiply)
            END
        ) AS total_daily_penalties,
          COUNT(CASE
        WHEN ewh.total_worked_hours = 0 AND total_late_arrival_minutes = 0 AND total_early_departure_minutes = 0 THEN 1
        ELSE NULL
    END) AS total_absence_days,
      COUNT(CASE
        WHEN ewh.total_worked_hours > 0  THEN 1
        ELSE NULL
    END) AS total_attendace_days
    FROM employees_worked_hours ewh
    WHERE ewh.date BETWEEN '$start_date' AND '$end_date'
    GROUP BY ewh.user_hash
) b
LEFT JOIN (
    SELECT
        v.user_hash,
        COALESCE(SUM(CASE WHEN v.vication_type_hash = 111 THEN TIMESTAMPDIFF(DAY, v.date_start, v.date_end) ELSE 0 END), 0) AS total_sick_leave_days,
        COALESCE(SUM(CASE WHEN v.vication_type_hash = 222 THEN TIMESTAMPDIFF(DAY, v.date_start, v.date_end) ELSE 0 END), 0) AS total_regular_leave_days,
        COALESCE(SUM(CASE WHEN v.vication_type_hash = 333 THEN TIMESTAMPDIFF(DAY, v.date_start, v.date_end) ELSE 0 END), 0) AS total_time_leave_days,
        COALESCE(SUM(CASE WHEN v.vication_type_hash = 444 THEN TIMESTAMPDIFF(DAY, v.date_start, v.date_end) ELSE 0 END), 0) AS total_duty_days,
        COALESCE(SUM(CASE WHEN v.vication_type_hash = 555 THEN TIMESTAMPDIFF(DAY, v.date_start, v.date_end) ELSE 0 END), 0) AS total_unpaid_leave_days,
        COALESCE(SUM(CASE WHEN v.vication_type_hash = 666 THEN TIMESTAMPDIFF(DAY, v.date_start, v.date_end) ELSE 0 END), 0) AS total_weekly_off_days,
COALESCE(SUM(TIMESTAMPDIFF(DAY, v.date_start, v.date_end)), 0) AS total_vacation_days
    FROM vacations v
    WHERE v.status = 111
        AND v.date_start >= '$start_date'
        AND v.date_end <= '$end_date'
    GROUP BY v.user_hash
) l ON b.user_hash = l.user_hash
LEFT JOIN system_users su ON b.user_hash = su.hash";

        if (!empty($user_hash)) {
            $sql .= " WHERE b.user_hash = ?";
        }

        $query = $this->db->query($sql, [$user_hash]);

        $result = $query->result_array();
        return [
            'count' => $count,
            'result' => $result,
        ];
    }

    public function convertToAmPm($time)
    {
        // Check if the input is a string and try to parse it as a date-time
        if (is_string($time)) {
            $dateTime = DateTime::createFromFormat('Y-m-d H:i:s', $time);
            if ($dateTime) {
                return $dateTime->format('g:i') . ' ' . ($dateTime->format('A') === 'AM' ? 'صباحا' : 'مساء');
            } else {
                return 'Invalid input';
            }
        }

        // Handle integer hour input
        if (is_numeric($time)) {
            // Convert to integer hour part
            $hour = (int) $time;

            // Handle midnight and noon cases
            if ($hour == 0) {
                return "12 صباحا"; // Midnight
            } elseif ($hour == 12) {
                return "12 مساء"; // Noon
            } elseif ($hour > 12) {
                return ($hour - 12) . " مساء"; // Convert to PM if hour > 12
            } else {
                return $hour . " صباحا"; // Convert to AM
            }
        }

        return 'Invalid input';
    }

    public function get_daily_records($user_hash, $start_date, $end_date)
    {

        $curDate = date('Y-m-d'); // Current date
        $penaltyMutiply = $this->EmployeesWorkedHoursModel->getMainPenalty();

        // Query to get the employee's daily records, including 'in' and 'out' entries
        $sql = "
        WITH RECURSIVE DateRange AS (
            SELECT ? AS date
            UNION ALL
            SELECT DATE_ADD(date, INTERVAL 1 DAY)
            FROM DateRange
            WHERE date < ?
        )
        SELECT
            json_extract(ach.schedule_data, '$') AS schedule_data,
            ach.allowance_time AS allowance_time,
            emp.user_hash,
            dr.date,
            ef_in.fingerprint_time AS in_time,
            ef_out.fingerprint_time AS out_time,
            TIME_FORMAT(SEC_TO_TIME(ewh.total_worked_hours * 3600), '%H:%i:%s') AS work_hour,
            TIME_FORMAT(SEC_TO_TIME(ewh.target_hours * 3600), '%H:%i:%s') AS work_hour_target,
            TIME_FORMAT(SEC_TO_TIME(ewh.overtime_hours * 3600), '%H:%i:%s') AS over_time,
            TIME_FORMAT(SEC_TO_TIME(ewh.total_missed_hours * 3600), '%H:%i:%s') AS missed_hours,
            TIME_FORMAT(SEC_TO_TIME(ewh.total_late_arrival_minutes * 60), '%H:%i:%s') AS finger_limit_in,
            TIME_FORMAT(SEC_TO_TIME(ewh.total_early_departure_minutes * 60), '%H:%i:%s') AS finger_limit_out,
            TIME_FORMAT(SEC_TO_TIME(
                CASE
                    WHEN ewh.total_worked_hours = 0 AND ewh.total_late_arrival_minutes = 0 AND ewh.total_early_departure_minutes= 0 AND v.user_hash IS NULL THEN ewh.total_missed_hours * 3600 * ?
                    WHEN ewh.total_worked_hours = 0 AND ewh.total_late_arrival_minutes = 0 AND ewh.total_early_departure_minutes= 0 AND v.user_hash IS NOT NULL THEN ewh.total_missed_hours * 3600
                    ELSE (ewh.total_late_arrival_minutes * 60 * ?) + (ewh.total_early_departure_minutes * 60 * ?)
                END
            ), '%H:%i:%s') AS total_penalty_hours,
            TIME_FORMAT(SEC_TO_TIME(
                CASE
                    WHEN ewh.total_worked_hours = 0 AND ewh.total_late_arrival_minutes = 0 AND ewh.total_early_departure_minutes= 0 AND v.user_hash IS NULL THEN ewh.total_missed_hours * 3600 
                    WHEN ewh.total_worked_hours = 0 AND ewh.total_late_arrival_minutes = 0 AND ewh.total_early_departure_minutes= 0 AND v.user_hash IS NOT NULL THEN ewh.total_missed_hours * 3600
                    ELSE (ewh.total_late_arrival_minutes * 60 ) + (ewh.total_early_departure_minutes * 60 )
                END
            ), '%H:%i:%s') AS total_missing_hours,

            CASE
                WHEN ewh.total_worked_hours = 0 AND ewh.total_late_arrival_minutes = 0 AND ewh.total_early_departure_minutes= 0 THEN 1
                ELSE 0
            END AS total_absence_days,

            CASE
                WHEN ewh.total_worked_hours > 0 THEN 1
                ELSE 0
            END AS total_attendace_days,
            CASE
                WHEN v.user_hash IS NOT NULL THEN 'vacation'
                WHEN v.user_hash IS NULL AND ef_in.user_hash IS NULL THEN 'absence'
                ELSE 'workday'
            END AS day_describe,
            CASE
                WHEN v.user_hash IS NOT NULL AND emp.is_work = '1' THEN vt.type
                WHEN v.user_hash IS NOT NULL AND emp.is_work = '0' THEN 'متوقف عن العمل'
                WHEN v.user_hash IS NULL AND ef_in.user_hash IS NULL THEN 'غياب'
                ELSE 'يوم عمل'
            END AS day_status,
             ROUND(emp.primary_salary / NULLIF(
        (SELECT SUM(ewh_inner.target_hours)
         FROM employees_worked_hours ewh_inner
         WHERE ewh_inner.user_hash = emp.user_hash
           AND ewh_inner.date BETWEEN '$start_date' AND '$end_date'
        ), 0), 2) AS hourly_rate,
        '$penaltyMutiply' AS penatly_multiplier,
             emp.primary_salary,
              SUM(ewh.target_hours) AS hourly_rate_test,
            ewh.details
        FROM emp_information emp
        CROSS JOIN DateRange dr
        LEFT JOIN employees_worked_hours ewh ON emp.user_hash = ewh.user_hash AND dr.date = ewh.date
        LEFT JOIN actual_schedules ach ON emp.user_hash = ach.user_hash AND dr.date = ach.date
        LEFT JOIN daily_flexible_schedule_targets dft ON emp.user_hash = dft.user_hash AND dr.date = dft.date
        LEFT JOIN vacations v ON emp.user_hash = v.user_hash
            AND (
                (dr.date BETWEEN DATE(v.date_start) AND DATE_SUB(DATE(v.date_end), INTERVAL 1 DAY) AND v.date_start <> v.date_end)
                OR (dr.date = DATE(v.date_start) AND v.date_start = v.date_end)
                OR (dr.date = DATE(v.date_start) AND DATE(v.date_end) = dr.date)
                )
            AND v.status = '111'
        LEFT JOIN vacations_type vt ON v.vication_type_hash = vt.hash
        LEFT JOIN (
            SELECT user_hash, fingerprint_time, id
            FROM emp_fingerprint
            WHERE in_out = 'in'
        ) ef_in ON emp.user_hash = ef_in.user_hash AND DATE(ef_in.fingerprint_time) = dr.date
        LEFT JOIN (
            SELECT user_hash, fingerprint_time, in_out_reference
            FROM emp_fingerprint
            WHERE in_out = 'out'
            AND in_out_reference IS NOT NULL
        ) ef_out ON emp.user_hash = ef_out.user_hash AND ef_out.in_out_reference = ef_in.id
        WHERE emp.user_hash = ?
            AND (ach.user_hash IS NOT NULL OR dft.user_hash IS NOT NULL)
        group by dr.date
        ORDER BY dr.date ASC
        
        ";

        // Execute the query with prepared statements
        $query = $this->db->query($sql, [$start_date, $end_date, $penaltyMutiply, $penaltyMutiply, $penaltyMutiply, $user_hash]);        // here is my flage if inTime here not appears , (and out here with reference something went wrong okay)
        $schedule_data = $query->result_array();

        if ($end_date > $curDate) {
            $curDateObject = new DateTime($curDate);
            $curDateObject->modify('+1 day');
            $endDateObject = new DateTime($end_date);

            // Loop through future dates and add data
            while ($curDateObject <= $endDateObject) {
                $curDatePlusOne = $curDateObject->format('Y-m-d');

                // Check if flexible or scheduled and add data accordingly
                if ($this->isFlexibleEmployee($user_hash)) {
                    $target_hours = $this->getTargetHours($user_hash); // Function to get target hours for flexible employees
                    $schedule_data[] = [
                        'user_hash' => $user_hash,
                        'date' => $curDatePlusOne,
                        'work_hour_target' => $this->formatHoursToHHMMSS($target_hours),
                        'finger_limit_in' => '00:00:00',
                        'finger_limit_out' => '00:00:00',
                        'work_hour' => '00:00:00',
                        'missed_hours' => $this->formatHoursToHHMMSS($target_hours),
                        'total_penalty_hours' => $this->formatHoursToHHMMSS($target_hours),
                        'day_describe' => 'workday_notCome',
                        'day_status' => 'يوم عمل لم ياتى',
                        'schedule_data' => null,
                    ];
                } else {
                    $schedule = $this->getEmployeeScheduleForDate($user_hash); // Retrieve scheduled hours for strict schedule
                    $scheduleData = json_decode($schedule['schedule_data'], true);

                    // Fetch vacation days for the current employee
                    $vacationSql = "SELECT dv.en_label
                FROM user_vacations uv
                JOIN days_of_week dv ON uv.day_of_week_id = dv.id
                WHERE uv.user_hash = ?";
                    $vacationDays = $this->db->query($vacationSql, [$user_hash])->result_array();
                    $vacationDaysArray = array_column($vacationDays, 'en_label');

                    // Get the current day of the week
                    $dayOfWeek = $curDateObject->format('l'); // 'l' returns the full textual representation of the day

                    if (in_array($dayOfWeek, $vacationDaysArray)) {
                        // Move to the next day
                        $curDateObject->modify('+1 day');
                        // Ensure this is within a loop to use continue
                        continue; // Skip penalty calculation
                    }

                    // Check if there is a schedule for the current day
                    if (isset($scheduleData[$dayOfWeek]) && !empty($scheduleData[$dayOfWeek])) {
                        $scheduleForDay = $scheduleData[$dayOfWeek];

                        // Example: Process the schedule for the current day
                        foreach ($scheduleForDay as $scheduleItem) {

                            // Access start and end times
                            $start = $scheduleItem['start'];
                            $end = $scheduleItem['end'];
                            $target_hours = $end - $start;

                            // Add your logic here to handle the schedule item
                            // For example, you can format the hours and add them to the schedule_data array
                            $schedule_data[] = [
                                'user_hash' => $user_hash,
                                'date' => $curDatePlusOne,
                                'schedule_data' => json_encode($scheduleItem),
                                'finger_limit_in' => '00:00:00',
                                'finger_limit_out' => '00:00:00',
                                'work_hour' => '00:00:00',
                                'missed_hours' => $this->formatHoursToHHMMSS($target_hours),
                                'work_hour_target' => $this->formatHoursToHHMMSS($target_hours),
                                'total_penalty_hours' => $this->formatHoursToHHMMSS($target_hours),
                                'day_describe' => 'workday_notCome',
                                'day_status' => 'يوم عمل لم ياتى',

                            ];
                        }
                    }
                }

                // Increment date
                $curDateObject->modify('+1 day');
            }
        }

        // Process the schedule data
        foreach ($schedule_data as &$record) {
            $schedule = json_decode($record['schedule_data'], true);
            if (json_last_error() === JSON_ERROR_NONE) {
                $record['start_times'] = [];
                $record['end_times'] = [];
                foreach ($schedule as $entry) {
                    if (isset($entry['start'])) {
                        $record['start_times'][] = $this->convertToAmPm($entry['start']);
                        $record['end_times'][] = $this->convertToAmPm($entry['end']);
                    }

                    // here third flage var_dump this
                    if (isset($record['in_time'])) {
                        $cnvertedToAmPm = $this->convertToAmPm($record['in_time']);
                        if ($cnvertedToAmPm !== "Invalid input") {
                            $record['in_time'] = $cnvertedToAmPm;
                        }
                    }
                    if (isset($record['out_time'])) {
                        $cnvertedToAmPm = $this->convertToAmPm($record['out_time']);
                        if ($cnvertedToAmPm !== "Invalid input") {
                            $record['out_time'] = $cnvertedToAmPm;
                        }
                    }
                }
            } else {
                $record['start_times'] = null; // Handle JSON decode error
                $record['end_times'] = null;
            }

        }

        return ['data' => $schedule_data, 'status' => 200];
        // return $schedule_data;
    }

    private function isFlexibleEmployee($user_hash)
    {
        $this->db->select("id")->from("emp_information")->where('user_hash', $user_hash)->where('flexible_schedule', '1');

        $query = $this->db->get();

        if ($query->num_rows() > 0) {
            return true;
        }
        return false;
    }

    private function getTargetHours($user_hash)
    {
        $query = $this->db->select('target_hours')
            ->from('emp_information')
            ->where('user_hash', $user_hash)
            ->get();

        // Check if the query returned a result
        if ($query->num_rows() > 0) {
            $row = $query->row();
            return (float) $row->target_hours;
        } else {
            return 0;
        }
    }

    private function convertHHMMSSToHours($timeString)
    {
        list($hours, $minutes, $seconds) = explode(':', $timeString);
        return $hours + ($minutes / 60) + ($seconds / 3600);
    }

    private function formatHoursToHHMMSS($hours)
    {
        // Calculate hours, minutes, and seconds
        $hoursInt = floor($hours);
        $minutes = floor(($hours - $hoursInt) * 60);
        $seconds = 0; // Assuming seconds are 0 since we typically deal with whole hours

        // Format the result to HH:MM:SS
        return sprintf('%02d:%02d:%02d', $hoursInt, $minutes, $seconds);
    }

    private function getEmployeeScheduleForDate($user_hash)
    {
        $query = $this->db->query("
           SELECT
                    sg.schedule_data
                FROM
                    emp_information ei
                JOIN
                    schedule_groups sg ON ei.work_schedule = sg.id
                WHERE user_hash = '$user_hash';
        ");

        if ($query->num_rows() > 0) {
            return $query->row_array();
        }
        return null;
    }

    // get today report of employee
    public function get_today_report($search = '')
    {
        $query = $this->db->query("
            SELECT
                name,
                system_users.hash as hash,
                (SELECT name FROM system_group_name WHERE system_group_name.hash=user_type) as job_name,
                (SELECT name FROM partments WHERE partments.hash=partment) as department_name,
                (SELECT Name FROM Positions WHERE Positions.ID=emp_information.position) as position,
                (SELECT PositionTypeID FROM Positions WHERE Positions.ID=emp_information.position) as PositionTypeID,
                image_profile,
                CASE
                    WHEN (SELECT type FROM holiday WHERE date = CURDATE()) IS NULL THEN 'يوم عمل'
                    ELSE (SELECT type FROM holiday WHERE date = CURDATE())
                END AS status,
                CASE
                    -- WHEN TIME(NOW()) < work_from OR TIME(NOW()) > work_to THEN 'خارج وقت الدوام'
                    WHEN EXISTS (
                        SELECT 1
                        FROM vacations
                        WHERE vacations.user_hash = system_users.hash
                        AND CURDATE() BETWEEN DATE(date_start) AND DATE(date_end - INTERVAL 1 DAY)
                        AND vacations.status = '111'
                        -- AND vacations.vication_type_hash IN ('111', '222', '333', '444', '555')
                    ) THEN 'مجاز'
                    WHEN COUNT(*) = 0 THEN 'لم يحضر بعد'
                    WHEN COUNT(*) = 1 AND MIN(emp_fingerprint.fingerprint_time) IS NULL THEN 'لم يحضر بعد'
                    WHEN COUNT(CASE WHEN in_out = 'in' THEN 1 END) >= 1 THEN 'حاضر'
                    WHEN COUNT(*) = 1 AND in_out = 'out' THEN 'بصم خروج بدون دخول'
                     -- WHEN COUNT(*) = 1 AND allow_time <= TIME(MIN(emp_fingerprint.fingerprint_time)) THEN 'متاخر عن العمل'
                     -- WHEN COUNT(*) = 1 AND allow_time >= TIME(MIN(emp_fingerprint.fingerprint_time)) THEN 'حاضر'
                     -- WHEN COUNT(*) = 2 AND allow_time < TIME(MIN(emp_fingerprint.fingerprint_time)) THEN 'متاخر عن العمل'
                    ELSE 'حضر وانتهي دوامه'
                END AS title,
                CASE
                    WHEN COUNT(*)  < 2 THEN ''
                    ELSE TIME_FORMAT(MAX(emp_fingerprint.fingerprint_time), '%h:%i %p')
                END AS outTime,
                CASE
                    WHEN COUNT(*) > 0 AND emp_fingerprint.in_out = 'in'  THEN TIME_FORMAT(MIN(emp_fingerprint.fingerprint_time), '%h:%i %p')
                    ELSE ''
                END AS inTime,
                CASE
                    WHEN COUNT(*) = 1 THEN TIMESTAMPDIFF(minute,MIN(fingerprint_time),CURTIME())/60
                    WHEN COUNT(*) = 2 THEN TIMESTAMPDIFF(minute,MIN(fingerprint_time),MAX(fingerprint_time))/60
                    ELSE ''
                END AS time_difference
            FROM
                system_users
                LEFT JOIN emp_fingerprint ON user_hash = system_users.hash
                    AND DATE(emp_fingerprint.fingerprint_time) = DATE(CURDATE())
                JOIN emp_information ON system_users.hash = emp_information.user_hash
                    AND is_work = 1
                LEFT JOIN vacations ON vacations.user_hash = system_users.hash
                    AND CURDATE() BETWEEN vacations.date_start AND vacations.date_end
            WHERE name LIKE '%$search%'
            GROUP BY system_users.hash, DATE(emp_fingerprint.fingerprint_time)
            ORDER BY
                CASE
                    WHEN (SELECT PositionTypeID FROM Positions WHERE Positions.ID = emp_information.position) = 3 THEN 1
                    ELSE 2
                END,
                CASE
                    WHEN (SELECT PositionTypeID FROM Positions WHERE Positions.ID = emp_information.position) = 4
                        AND (SELECT Name FROM Positions WHERE Positions.ID = emp_information.position) = 'قسم الموارد البشرية' THEN 1
                    WHEN (SELECT Name FROM Positions WHERE Positions.ID = emp_information.position) LIKE '%قسم%' THEN 2
                    ELSE 3
                END,
                CASE
                    WHEN (SELECT Name FROM Positions WHERE Positions.ID = emp_information.position) LIKE '%محل%' THEN 1
                    WHEN (SELECT Name FROM Positions WHERE Positions.ID = emp_information.position) LIKE '%فرع%' THEN 2
                    ELSE 3
                END,
                (SELECT Name FROM Positions WHERE Positions.ID = emp_information.position) ASC;
        ");

        return $query->result_array();
    }

    public function updateStatusInNotPhone($hash)
    {
        $this->db->query("update device_log set status = '0' where hash = '$hash'");
    }

    public function getFingerprintLog($start_date = '2023-01-01', $end_date = '3000-01-01', $employee_name = '')
    {
        //$search = $this->input->post('q') ?? '';
        $page = intval($this->input->post("page")) ?? 1;
        $perPage = intval($this->input->post("perPage")) ?? 10;
        $offset = ($page - 1) * $perPage;
        $query = $this->db->query(
            "
            SELECT
                DATE(fingerprint_time) AS date,
                TIME_FORMAT(MIN(fingerprint_time), '%h:%i %p') AS inTime,
                case
                    when count(*) = 1 then 'لم يخرج بعد'
                    else TIME_FORMAT(MAX(fingerprint_time), '%h:%i %p')
                end as outTime,
                TIMESTAMPDIFF(minute,
                    MIN(fingerprint_time),
                    MAX(fingerprint_time))/60 AS time_difference,
                fing.hash,
                (select name from system_group_name where hash=(select user_type from system_users where hash=fing.user_hash)) as job,
                system_users.name AS name,
                system_users.image_profile AS image,
                (select name from partments where hash=emp_information.partment) as part,
                fing.user_hash,
                case
                    when count(*) =0 then 'لم يحضر'
                    when count(*) = 1 and in_out='in' and allow_time > TIME(MIN(fingerprint_time)) then 'حضر في ميعادة ولم يخرج بعد'
                    when count(*) = 1 and in_out='out' then 'بصم خروج بدون دخول'
                    when count(*) = 2 and allow_time > TIME(MIN(fingerprint_time)) then 'حضر في ميعاده وخرج'
                    when count(*) = 2 and allow_time < TIME(MIN(fingerprint_time)) then 'حضر متاخر'
                    else 'راجع السيستم'
                end as status,
                ST_X(location) AS lat,
                ST_Y(location) AS lng,
                (select ST_X(location) from emp_fingerprint outFing where in_out='out' and date(outFing.fingerprint_time) = date(fing.fingerprint_time) and fing.user_hash = outFing.user_hash limit 1) as out_lat,
                (select ST_Y(location) from emp_fingerprint outFing where in_out='out' and date(outFing.fingerprint_time) = date(fing.fingerprint_time) and fing.user_hash = outFing.user_hash limit 1) as out_lng
            FROM
                emp_fingerprint fing
            left join emp_information on emp_information.user_hash= fing.user_hash
            left join system_users on system_users.hash = fing.user_hash
            where date(fing.fingerprint_time) >= '$start_date' and date(fing.fingerprint_time) <= '$end_date' and system_users.name like '%$employee_name%'
            GROUP BY fing.user_hash , DATE(fingerprint_time),partment
            ORDER BY fing.fingerprint_time DESC
            LIMIT $offset, $perPage
            "
        );
        $result = $query->result_array();
        return $result;
    }

    public function deleteFingerprintLog($hash)
    {
        $this->db->where('hash', $hash);
        $this->db->delete('emp_fingerprint_log');
        return $this->db->affected_rows();
    }

    public function countFingerprintLog($start_date = '2000-01-01', $end_date = '3000-01-01', $employee_name = '')
    {
        $this->db->select(" COUNT(DISTINCT emp_fingerprint.user_hash, DATE(fingerprint_time)) AS count");
        $this->db->from("emp_fingerprint");
        $this->db->join("emp_information", "emp_information.user_hash = emp_fingerprint.user_hash", "LEFT");
        $this->db->join("system_users", "system_users.hash = emp_fingerprint.user_hash", "INNER");
        $this->db->where("DATE(fingerprint_time) BETWEEN '$start_date' AND '$end_date'");
        if (!empty($employee_name)) {
            $this->db->like("system_users.name", $employee_name);
        }
        $query = $this->db->get();
        $result = $query->row_array();
        return isset($result['count']) ? $result['count'] : 0;
    }
}
