<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Scheduled_tasks_model extends CI_Model
{

    public function __construct()
    {
        parent::__construct();
        $this->load->database();

    }

    // Method to insert a new task
    public function insert_task($task_type, $task_data, $execute_at)
    {
        $data = array(
            'task_type' => $task_type,
            'task_data' => json_encode($task_data),
            'execute_at' => $execute_at,
        );

        $this->db->insert('scheduled_tasks', $data);
        return $this->db->insert_id();
    }

    // Method to update the status of a task
    public function update_task_status($task_id, $status, $executed_at = null)
    {
        $data = array(
            'status' => $status,
            'executed_at' => $executed_at,
        );

        $this->db->where('id', $task_id);
        return $this->db->update('scheduled_tasks', $data);
    }

    // Method to get a task by ID
    public function get_task_by_id($task_id)
    {
        $query = $this->db->get_where('scheduled_tasks', array('id' => $task_id));
        return $query->row_array();
    }

    // Method to get all tasks with a specific status
    public function get_tasks_by_status($status)
    {
        $query = $this->db->get_where('scheduled_tasks', array('status' => $status));
        return $query->result_array();
    }
}
