<?php
class UserAttachmentModel extends CI_Model
{
    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    // إضافة عميل
    public function add($data)
    {
        $this->db->insert('users_attachment', $data);
        return $this->db->insert_id();
    }

    // تحديث عميل
    public function update($hash, $data)
    {
        $this->db->where('hash', $hash);
        $this->db->update('users_attachment', $data);
        return $this->db->affected_rows();
    }

    // حذف عميل
    public function delete($hash)
    {
        $this->db->where('hash', $hash);
        $this->db->delete('users_attachment');
        return $this->db->affected_rows();
    }

    // استرداد عميل بالهاش
    public function get($hash)
    {
        $query = $this->db->get_where('users_attachment', array('hash' => $hash));
        return $query->row_array();
    }

    // استرداد كل المشاريع
    public function get_all($user_hash)
    {
        $this->db->select('*');
        $this->db->from('users_attachment');
        $this->db->where('user_hash', $user_hash);
        $query = $this->db->get();
        return $query->result_array();
    }
}