<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Zk_fingerprintsLogsModel extends CI_Model
{
    protected $table = 'zk_fingerprints_log';

    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    public function getAll()
    {
        return $this->db->get($this->table)->result_array();
    }

    public function get_fingerprint_logs()
    {
        $page = $this->input->get('page') ?? 1;
        $perPage = $this->input->get('perPage') ?? 10;
        $offset = ($page - 1) * $perPage;
        $search = $this->input->get('q') ?? '';
        $status = $this->input->get('status') ?? '';

        // Query for paginated results
        // $sql = "
        //     SELECT 
        //         system_users.name,
        //         zk_devices.name AS device_name,
        //         zk_fingerprints_log.*,
        //         zk_devices.lat,
        //         zk_devices.lng,
        //         emp_fingerprint_approval.fingerprint_type,
        //         CASE
        //             WHEN emp_fingerprint.user_hash IS NOT NULL THEN 'success'
        //             WHEN emp_fingerprint_approval.user_hash IS NOT NULL THEN 'failed'
        //             ELSE 'pending'
        //         END AS status,
        //         CASE
        //             WHEN emp_fingerprint_approval.user_hash IS NOT NULL THEN emp_fingerprint_approval.reason_for_approval
        //             ELSE ''
        //         END AS message,
        //         CASE 
        //             WHEN zk_fingerprints_log.indRegId IN ('0', '4') THEN 'in' 
        //             WHEN zk_fingerprints_log.indRegId IN ('1', '5') THEN 'out' 
        //             ELSE NULL 
        //         END AS in_out_status
        //     FROM zk_fingerprints_log
        //     JOIN system_users ON system_users.hash = zk_fingerprints_log.user_hash
        //     JOIN zk_devices ON zk_devices.device_info = zk_fingerprints_log.device_info
        //     LEFT JOIN emp_fingerprint 
        //         ON emp_fingerprint.user_hash = zk_fingerprints_log.user_hash
        //         AND emp_fingerprint.fingerprint_time = zk_fingerprints_log.dateTime
        //         AND emp_fingerprint.fingerprint_type = '222'
        //         AND emp_fingerprint.in_out = CASE
        //             WHEN zk_fingerprints_log.indRegId IN ('0', '4') THEN 'in'
        //             WHEN zk_fingerprints_log.indRegId IN ('1', '5') THEN 'out'
        //         END
        //     LEFT JOIN emp_fingerprint_approval 
        //         ON emp_fingerprint_approval.user_hash = zk_fingerprints_log.user_hash
        //         AND emp_fingerprint_approval.fingerprint_time = zk_fingerprints_log.dateTime
        //         AND emp_fingerprint_approval.fingerprint_type = '222'
        //         AND emp_fingerprint_approval.in_out = CASE
        //             WHEN zk_fingerprints_log.indRegId IN ('0', '4') THEN 'in'
        //             WHEN zk_fingerprints_log.indRegId IN ('1', '5') THEN 'out'
        //         END
        //     WHERE zk_fingerprints_log.indRegId IN ('0', '1', '4', '5')
        //     AND (system_users.name LIKE ? OR zk_devices.name LIKE ?) 
        //     GROUP BY zk_fingerprints_log.id
        //     ORDER BY zk_fingerprints_log.id DESC
        //     LIMIT ? OFFSET ?";


        $sql = "
        SELECT *
FROM (
    SELECT 
        system_users.name,
        zk_devices.name AS device_name,
        zk_fingerprints_log.*,
        zk_devices.lat,
        zk_devices.lng,
        emp_fingerprint_approval.fingerprint_type,
        CASE
            WHEN emp_fingerprint.user_hash IS NOT NULL THEN 'success'
            WHEN emp_fingerprint_approval.user_hash IS NOT NULL THEN 'failed'
            ELSE 'pending'
        END AS status,
        CASE 
            WHEN emp_fingerprint_approval.user_hash IS NOT NULL THEN emp_fingerprint_approval.reason_for_approval
            ELSE ''
        END AS message,
        CASE 
            WHEN zk_fingerprints_log.indRegId IN ('0', '4') THEN 'in' 
            WHEN zk_fingerprints_log.indRegId IN ('1', '5') THEN 'out' 
            ELSE NULL 
        END AS in_out_status,
        ROW_NUMBER() OVER (
            PARTITION BY 
                zk_fingerprints_log.user_hash, 
                zk_fingerprints_log.dateTime, 
                CASE 
                    WHEN zk_fingerprints_log.indRegId IN ('0', '4') THEN 'in' 
                    WHEN zk_fingerprints_log.indRegId IN ('1', '5') THEN 'out' 
                    ELSE NULL 
                END 
            ORDER BY zk_fingerprints_log.id DESC
        ) AS row_num
    FROM zk_fingerprints_log
    JOIN system_users ON system_users.hash = zk_fingerprints_log.user_hash
    JOIN zk_devices ON zk_devices.device_info = zk_fingerprints_log.device_info
    LEFT JOIN emp_fingerprint 
        ON emp_fingerprint.user_hash = zk_fingerprints_log.user_hash
        AND emp_fingerprint.fingerprint_time = zk_fingerprints_log.dateTime
        AND emp_fingerprint.fingerprint_type = '222'
        AND emp_fingerprint.in_out = CASE
            WHEN zk_fingerprints_log.indRegId IN ('0', '4') THEN 'in'
            WHEN zk_fingerprints_log.indRegId IN ('1', '5') THEN 'out'
        END
    LEFT JOIN emp_fingerprint_approval 
        ON emp_fingerprint_approval.user_hash = zk_fingerprints_log.user_hash
        AND emp_fingerprint_approval.fingerprint_time = zk_fingerprints_log.dateTime
        AND emp_fingerprint_approval.fingerprint_type = '222'
        AND emp_fingerprint_approval.in_out = CASE
            WHEN zk_fingerprints_log.indRegId IN ('0', '4') THEN 'in'
            WHEN zk_fingerprints_log.indRegId IN ('1', '5') THEN 'out'
        END
    WHERE zk_fingerprints_log.indRegId IN ('0', '1', '4', '5')
    AND (system_users.name LIKE ? OR zk_devices.name LIKE ?) 
" . (!empty($status) ? "AND (CASE
            WHEN emp_fingerprint.user_hash IS NOT NULL THEN 'success'
            WHEN emp_fingerprint_approval.user_hash IS NOT NULL THEN 'failed'
            ELSE 'pending'
        END) = ?" : "") . ") AS subquery
WHERE row_num = 1
ORDER BY id DESC
LIMIT ? OFFSET ?;
";

        // Query for total count (without ORDER, LIMIT, and CASE)
        $countSql = "
        SELECT COUNT(*) AS total
        FROM (
            SELECT 
                ROW_NUMBER() OVER (
                    PARTITION BY 
                        zk_fingerprints_log.user_hash, 
                        zk_fingerprints_log.dateTime, 
                        CASE 
                            WHEN zk_fingerprints_log.indRegId IN ('0', '4') THEN 'in' 
                            WHEN zk_fingerprints_log.indRegId IN ('1', '5') THEN 'out' 
                            ELSE NULL 
                        END 
                    ORDER BY zk_fingerprints_log.id DESC
                ) AS row_num,
                CASE
                    WHEN emp_fingerprint.user_hash IS NOT NULL THEN 'success'
                    WHEN emp_fingerprint_approval.user_hash IS NOT NULL THEN 'failed'
                    ELSE 'pending'
                END AS status
            FROM zk_fingerprints_log
            JOIN system_users ON system_users.hash = zk_fingerprints_log.user_hash
            JOIN zk_devices ON zk_devices.device_info = zk_fingerprints_log.device_info
            LEFT JOIN emp_fingerprint 
                ON emp_fingerprint.user_hash = zk_fingerprints_log.user_hash
                AND emp_fingerprint.fingerprint_time = zk_fingerprints_log.dateTime
                AND emp_fingerprint.fingerprint_type = '222'
                AND emp_fingerprint.in_out = CASE
                    WHEN zk_fingerprints_log.indRegId IN ('0', '4') THEN 'in'
                    WHEN zk_fingerprints_log.indRegId IN ('1', '5') THEN 'out'
                END
            LEFT JOIN emp_fingerprint_approval 
                ON emp_fingerprint_approval.user_hash = zk_fingerprints_log.user_hash
                AND emp_fingerprint_approval.fingerprint_time = zk_fingerprints_log.dateTime
                AND emp_fingerprint_approval.fingerprint_type = '222'
                AND emp_fingerprint_approval.in_out = CASE
                    WHEN zk_fingerprints_log.indRegId IN ('0', '4') THEN 'in'
                    WHEN zk_fingerprints_log.indRegId IN ('1', '5') THEN 'out'
                END
            WHERE zk_fingerprints_log.indRegId IN ('0', '1', '4', '5')
            AND (system_users.name LIKE ? OR zk_devices.name LIKE ?)
            " . (!empty($status) ? "AND (CASE
                    WHEN emp_fingerprint.user_hash IS NOT NULL THEN 'success'
                    WHEN emp_fingerprint_approval.user_hash IS NOT NULL THEN 'failed'
                    ELSE 'pending'
                END) = ?" : "") . "
        ) AS subquery
        WHERE row_num = 1;
    ";

        $countParams = [
            "%$search%",  // system_users.name LIKE
            "%$search%"   // zk_devices.name LIKE
        ];

        if (!empty($status)) {
            $countParams[] = $status;  // status filter
        }


        // Execute Queries with Bindings (Prevents SQL Injection)
        $params = [
            "%$search%",  // system_users.name LIKE
            "%$search%"   // zk_devices.name LIKE
        ];

        if (!empty($status)) {
            $params[] = $status;  // status filter
        }

        $params[] = (int) $perPage;
        $params[] = (int) $offset;

        $query = $this->db->query($sql, $params);
        $data = $query->result_array();

        $countQuery = $this->db->query($countSql, $countParams);
        $total = $countQuery->row_array()['total'];


        return ['data' => $data, 'total' => $total];
    }



    public function getById($id)
    {
        return $this->db->get_where($this->table, ['id' => $id])->row_array();
    }

    public function insert_log($data)
    {
        $this->db->insert($this->table, $data);
        return $this->db->insert_id();
    }

    public function delete($id)
    {
        $this->db->where('id', $id);
        return $this->db->delete($this->table);
    }
}