const { emailsShouldNotifiy } = require("./constants");
const db = require("./db");
const sendMail = require("./email");


const checkDatabase = async () => {
    try {
        const [rows] = await db.promise().query("SELECT * FROM data WHERE is_correct = FALSE");

        if (rows.length > 0) {
            console.log("Incorrect data found!");
            emailsShouldNotifiy.forEach(async (email) => {
                await sendMail(
                    email,
                    "Database Alert: Incorrect Data Found",
                    `Incorrect data found in the database: ${JSON.stringify(rows)}`
                );
            });

        } else {
            console.log("No incorrect data found.");
        }
    } catch (err) {
        console.error("Error monitoring database: ", err);
    }
};

module.exports = checkDatabase;